/************************************************************************************
****    Procedure para calculo do demonstrativo de resultado operacional       ******
*************************************************************************************
        RAISERROR('MENSAGEM' ,16,1);
Criado em  : 12/06/2007
       Por : Alessandra Cristina
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'APURAC_RESOPERFILI_DRF'  AND
	        TYPE = 'P' 			            AND
	        U.UID = O.UID             		AND
	        U.NAME = USER)

  DROP PROCEDURE APURAC_RESOPERFILI_DRF
  GO

CREATE PROCEDURE APURAC_RESOPERFILI_DRF @P_CDFILIAL       VARCHAR(4),
                                        @P_DTINICIAL      DATETIME,
                                        @P_DTFINAL        DATETIME,
                                        @P_IDCONSANT      VARCHAR(1) = 'N'
AS
   DECLARE @V_IDUTPADRROP        VARCHAR(1);
BEGIN
   SELECT @V_IDUTPADRROP = IDUTPADRROP
   FROM PARAMGERAL G;

END;

GO

ALTER PROCEDURE APURAC_RESOPERFILI_DRF @P_CDFILIAL       VARCHAR(4),
                                       @P_DTINICIAL      DATETIME,
                                       @P_DTFINAL        DATETIME,
                                       @P_IDCONSANT      VARCHAR(1) = 'N'

AS
   DECLARE @V_CDGRUPPROD      VARCHAR(10);
   DECLARE @V_NRFUNCROP       VARCHAR(10);
   DECLARE @V_IDEFETIVOROP    VARCHAR(1);
   DECLARE @V_IDCOMPRAROP     VARCHAR(1);
   DECLARE @V_IDAJUSTEROP     VARCHAR(1);

   DECLARE @V_IDIMPLANTROP    VARCHAR(1);
   DECLARE @V_IDINVFINAROP    VARCHAR(1);
   DECLARE @V_IDINVINICROP    VARCHAR(1);
   DECLARE @V_IDRETIRADAROP   VARCHAR(1);
   DECLARE @V_IDDESPDIVROP    VARCHAR(1);
   DECLARE @V_IDDESPENTROP    VARCHAR(1);
   DECLARE @V_IDDESPMOBROP    VARCHAR(1);
   DECLARE @V_IDFATUROP       VARCHAR(2);
   DECLARE @V_IDNFSAIDAROP    VARCHAR(1);
   DECLARE @V_VRADIANTROP     DOUBLE PRECISION;

   DECLARE @V_NRAPURREL       VARCHAR(20);
   DECLARE @V_CDPRODFIN       VARCHAR(20);
   DECLARE @V_CDPRODINI       VARCHAR(20);
   DECLARE @V_NRMOVIESTQ      VARCHAR(20);
   DECLARE @V_DTLANCMOVI      DATETIME;
   DECLARE @V_DTLANCMOVIF     DATETIME;

   DECLARE @V_NRROPFILIAL     VARCHAR(50);
   DECLARE @V_NRROPFIL        VARCHAR(50);
   DECLARE @V_NRROP	         VARCHAR(50);
   DECLARE @V_NRLANCROP       VARCHAR(20);
   DECLARE @V_NRITLANCROP     VARCHAR(20);
   DECLARE @V_NRSEQRELACIT    VARCHAR(10);
   DECLARE @V_NRTIPOCUSTO     DOUBLE PRECISION;

   DECLARE @V_CDCLIENTE          VARCHAR(21);
   DECLARE @V_CDTIPOOPER         VARCHAR(2);
   DECLARE @V_NRNOTAFISC         VARCHAR(20);
   DECLARE @V_CDFILIAL           VARCHAR(4);
   DECLARE @V_NRLANCTONF         VARCHAR(10);
   DECLARE @V_DTENTRSAID         DATETIME;
   DECLARE @V_CDSERIE            VARCHAR(5);
   DECLARE @V_CDPRODUTO          VARCHAR(20);
   DECLARE @V_NRSEQITPROD        VARCHAR(20);
   DECLARE @V_QUANTIDADE         DOUBLE PRECISION;
   DECLARE @V_VALORTOTAL         DOUBLE PRECISION;
   DECLARE @V_CDIMPOSTO          VARCHAR(2);
   DECLARE @V_IDTRATIMPROP       VARCHAR(1);
   DECLARE @V_CDSERVFILIAPGD     VARCHAR(20);
   DECLARE @V_CDCLIENTEAPGD      VARCHAR(21);
   DECLARE @V_DTAPURACFATGD      DATETIME;
   DECLARE @V_CDFILFATAPGD       VARCHAR(4);
   DECLARE @V_NRAPUFATAPGD       VARCHAR(20);
   DECLARE @V_VRESTOQDIA         DOUBLE PRECISION;
   DECLARE @V_QTESTOQDIA         DOUBLE PRECISION;
   DECLARE @V_NRRELATMOVI        VARCHAR(20);
   DECLARE @V_NRLANCMOVIEST      VARCHAR(20);
   DECLARE @V_CDFILIMOVIEST      VARCHAR(4);
   DECLARE @V_CDFILLANCMEST      VARCHAR(4);
   DECLARE @V_DTLANCMOVIEST      DATETIME
   DECLARE @V_QTLANCMOVIEST      DOUBLE PRECISION;
   DECLARE @V_CDPRODMOVIEST      VARCHAR(20);
   DECLARE @V_VRDIFECUST         DOUBLE PRECISION;
   DECLARE @V_CDSERVFILI         VARCHAR(20);
   DECLARE @V_DTCARDAPIO         DATETIME;
   DECLARE @V_CDFILIALLANC       VARCHAR(4);
   DECLARE @V_NRLANCESTQ         VARCHAR(20);
   DECLARE @V_VRCUSTPROD         DOUBLE PRECISION;
   DECLARE @V_QTRETIRADA         DOUBLE PRECISION;
   DECLARE @V_CDDESPPREV         VARCHAR(20);
   DECLARE @V_DTPRDESPFILI       DATETIME;
   DECLARE @V_VRPRDESPFILI       DOUBLE PRECISION;
   DECLARE @V_VRREDESPFILI       DOUBLE PRECISION;
   DECLARE @V_DTLANCDESFAT       DATETIME;
   DECLARE @V_CDDESPADMFAT       VARCHAR(20);
   DECLARE @V_VRLANCDESFAT       DOUBLE PRECISION;
   DECLARE @V_VRTXLANCDESP       DOUBLE PRECISION;
   DECLARE @V_VRPREVDESFAT       DOUBLE PRECISION;
   DECLARE @V_CDFORNECED         VARCHAR(21);
   DECLARE @V_DTLANCESTQ         DATETIME;
   DECLARE @V_CDPRODMOVI         VARCHAR(20);
   DECLARE @V_VRBRUTITEM         DOUBLE PRECISION;
   DECLARE @V_QTLANCTOEST        DOUBLE PRECISION;
   DECLARE @V_VRLANCTOESTQ       DOUBLE PRECISION;
   DECLARE @V_TEXT               VARCHAR(50);

   /*Variveis para calculo do consumo*/

   DECLARE @V_CONSUMO            DOUBLE PRECISION;
   DECLARE @V_NRCOUNT            DOUBLE PRECISION;
   DECLARE @V_NRCONS             DOUBLE PRECISION;
   DECLARE @V_VALOR              DOUBLE PRECISION;
   DECLARE @V_DTINICONS          DATETIME;

   DECLARE @V_CDFILIGR           VARCHAR(4);
   DECLARE @V_CDFILISUBGR        VARCHAR(4);
   DECLARE @V_VRIMPOSTO 	      DOUBLE PRECISION;
   DECLARE @V_PRODUTO            VARCHAR(20);
   DECLARE @V_NRSEQIT            VARCHAR(10);
   DECLARE @V_VALORIMPOSTO	      DOUBLE PRECISION;
   DECLARE @V_NRSEQUMOVIEST	   VARCHAR(10);
   DECLARE @V_IDDESTACAROP	      VARCHAR(2);
   DECLARE @V_DTINICROP		      DATETIME;
   DECLARE @V_DTFINALROP         DATETIME;

   DECLARE @V_STR                VARCHAR(20);
   DECLARE @V_IDUTPADRROP        VARCHAR(1);
   DECLARE @V_IDUTPADRROPFIL     VARCHAR(1);
   DECLARE @V_FILIALPAR          VARCHAR(4);
   DECLARE @V_IDFILIALAGRROP     VARCHAR(1);
   DECLARE @V_IDSERVRETROP       VARCHAR(1);
   DECLARE @V_DTINICIO           DATETIME
   DECLARE @V_DTFINAL            DATETIME;
   DECLARE @V_DTFILIALROP        DATETIME;
   DECLARE @V_NRITEM             DOUBLE PRECISION;
   DECLARE @V_CDFILCENTPME       VARCHAR(4);
   DECLARE @V_IDSERVFATROP       VARCHAR(1);
   DECLARE @V_NRMESCONSROP       DOUBLE PRECISION;
   DECLARE @V_CDFILCENTROP       VARCHAR(4);
   DECLARE @V_IDFECHDIAROP       VARCHAR(1);
   DECLARE @V_IDPERCONSROP	      VARCHAR(1);
   DECLARE @V_IDSTATUS           VARCHAR(1);
   DECLARE @V_DTINIREFEFAT	      DATETIME;
   DECLARE @V_DTFINREFEFAT       DATETIME;

   DECLARE @V_APURCONS           VARCHAR(10);
   DECLARE @V_DTLANCROP          DATETIME;
   DECLARE @V_NRROPFILINI        VARCHAR(20);
   DECLARE @V_NRDIAS             NUMERIC;
   DECLARE @V_CDFILIALIT         VARCHAR(04);
   DECLARE @V_NRLANCTONFIT       VARCHAR(10);
   DECLARE @V_CDFISCALIT         CHAR;

   DECLARE @V_ULTLANCMOVIEST     VARCHAR(20);
   DECLARE @V_DELNRLANCROP       VARCHAR(20);
   DECLARE @V_DELCDFILIAL        VARCHAR(04);

   /* variaveis do gesto merenda/HOSPITALAR */
   DECLARE @V_DTEFETCLPME        DATETIME;
   DECLARE @V_DTEFETDIET         DATETIME;
   DECLARE @V_NUMERORE           VARCHAR(10);
   DECLARE @V_VRCUSTLOGLAN       DOUBLE PRECISION;
   DECLARE @V_VRSEGULOGLAN       DOUBLE PRECISION;
   DECLARE @V_CDSUBGRPROD        VARCHAR(10);
   DECLARE @V_CDGRUPPRODRET      VARCHAR(10);
   DECLARE @V_CDFILIRECE         VARCHAR(04);
   DECLARE @V_CDGRUPPRODROP      VARCHAR(10);
   DECLARE @V_CDSUBGRPRODROP     VARCHAR(10);
   DECLARE @V_DTINIC             DATETIME;

   /* variavel do custo padrao sesso pu */
   DECLARE @V_DTLANCPADR         DATETIME;
   DECLARE @V_VRCUSTPADR         DOUBLE PRECISION;
   DECLARE @V_FILIAPURA          VARCHAR(4);
   DECLARE @V_DTPROCESSA         DATETIME;
   DECLARE @V_IDLANCDTMENFIL     VARCHAR(1);
   DECLARE @V_PRIIMP             NUMERIC;
   DECLARE @V_NRROPDIF           BIT;
   DECLARE @V_CDFILIALBO         VARCHAR(4);
   DECLARE @V_IDAPUCTPGROP       VARCHAR(1);

   DECLARE @V_CDFILIBPAG VARCHAR(4);
   DECLARE @V_NRSEQVENPAG VARCHAR(2);
   DECLARE @V_NRPARCELAPAG VARCHAR(2);
   DECLARE @V_CDTPCTPAGAR VARCHAR(6);
   DECLARE @V_DTBAIXAPAG   DATETIME;
   DECLARE @V_VRCONTARATEADA DOUBLE PRECISION;
   DECLARE @V_IDTPAPURACAO VARCHAR(1);

BEGIN

   SET @V_CONSUMO     = 0;
   SET @V_NRLANCROP   = 0;
   SET @V_NRITLANCROP = '00000';
   SET @V_DTPROCESSA  = GETDATE();

   /*Verifica parametrizao para gerao do ROP*/


   SELECT @V_IDUTPADRROP = IDUTPADRROP
   FROM PARAMGERAL G;


   SELECT @V_IDUTPADRROPFIL = IDUTPADRROPFIL,
          @V_CDFILCENTPME   = CDFILCENTPME
   FROM FILIAL F LEFT JOIN PARFILIALROP P ON
                     P.CDFILIAL = F.CDFILIAL
   WHERE
      F.CDFILIAL    = @P_CDFILIAL;


   IF (@V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S') BEGIN
      SET @V_FILIALPAR = 'P';
   END
   ELSE BEGIN
      IF @V_CDFILCENTPME IS NULL BEGIN
         SET @V_FILIALPAR = @P_CDFILIAL;
      END
      ELSE BEGIN
         SELECT @V_IDFILIALAGRROP = ISNULL(MAX(IDFILIALAGRROP),'N')
         FROM PARFILIALROP
         WHERE CDFILIAL = @V_CDFILCENTPME;

         IF @V_IDFILIALAGRROP = 'S' BEGIN
            SET @V_FILIALPAR = @V_CDFILCENTPME;
         END
         ELSE BEGIN
            SET @V_FILIALPAR = @P_CDFILIAL;
         END;
      END;
   END;

   /*Verifica parametrizao para gerao do ROP*/
    SELECT
       @V_CDGRUPPROD    =  MAX(CDGRUPPROD),
       @V_IDFATUROP     =  MAX(IDFATUROP),
       @V_IDEFETIVOROP  =  MAX(IDEFETIVOROP),
       @V_IDCOMPRAROP   =  MAX(IDCOMPRAROP),
       @V_IDNFSAIDAROP  =  MAX(IDNFSAIDAROP),
       @V_IDINVINICROP  =  MAX(IDINVINICROP),
       @V_IDIMPLANTROP  =  MAX(IDIMPLANTROP),
       @V_IDINVFINAROP  =  MAX(IDINVFINAROP),
       @V_IDAJUSTEROP   =  MAX(IDAJUSTEROP),
       @V_IDRETIRADAROP =  MAX(IDRETIRADAROP),
       @V_IDDESPDIVROP  =  MAX(IDDESPDIVROP),
       @V_IDDESPENTROP  =  MAX(IDDESPENTROP),
       @V_IDDESPMOBROP  =  MAX(IDDESPMOBROP),
       @V_IDSERVRETROP  =  MAX(IDSERVRETROP),
       @V_IDSERVFATROP  =  MAX(IDSERVFATROP),
       @V_NRMESCONSROP  =  ISNULL(MAX(NRMESCONSROP),1),
       @V_IDPERCONSROP  =  ISNULL(MAX(IDPERCONSROP), 'N'),
       @V_IDFECHDIAROP  =  ISNULL(MAX(IDFECHDIAROP), 'N'),
       @V_IDAPUCTPGROP  =  ISNULL(MAX(IDAPUCTPGROP), 'N'),
       @V_IDTPAPURACAO  =  ISNULL(MAX(IDTPAPURACAO), '1')
    FROM PARFILIALROP P, PARAMFILIAL F
    WHERE P.CDFILIAL = @V_FILIALPAR  AND
          F.CDFILIAL = @P_CDFILIAL;



   SELECT @V_NRTIPOCUSTO  = CONVERT(NUMERIC,ISNULL(CDTIPCUSTEST,'3')),
          @V_CDFILCENTROP =  CDFILCENTPME,
          @V_DTPROCESSA   = CASE IDUTILDTPROC WHEN 'S' THEN ISNULL(DTPROCESSA,GETDATE()) ELSE GETDATE() END

   FROM PARAMFILIAL P, FILIAL F, PARAMGERAL
   WHERE P.CDFILIAL = @P_CDFILIAL  AND
         P.CDFILIAL = F.CDFILIAL;


   /*Verifica se filial tem sub-grupo especfico*/

   DECLARE C_FILGRUPO CURSOR FOR
      SELECT DISTINCT CDFILISUBGR
      FROM PRSUBGRPROD
      WHERE CDGRUPPROD = @V_CDGRUPPROD
      ORDER BY CDFILISUBGR ASC;

   OPEN C_FILGRUPO ;
   FETCH NEXT FROM C_FILGRUPO  INTO @V_CDFILIGR;
   WHILE (@@FETCH_STATUS = 0)   BEGIN
       IF @V_CDFILIGR = @P_CDFILIAL BEGIN
          SET @V_CDFILISUBGR = @P_CDFILIAL;
          BREAK;
       END
       ELSE BEGIN
          SET @V_CDFILISUBGR = 'P';
       END;
      FETCH NEXT FROM C_FILGRUPO  INTO @V_CDFILIGR;
   END;
   CLOSE C_FILGRUPO;
   DEALLOCATE C_FILGRUPO;


   /*Verifica se a data compreendida no perodo parametrizado j foi apurada*/

   IF @P_IDCONSANT = 'N' BEGIN

      SET @V_DTINIC = @P_DTINICIAL;
      SET @V_FILIAPURA = @V_FILIALPAR;

      IF @V_FILIALPAR = 'P' BEGIN
         SET @V_FILIAPURA = @P_CDFILIAL;
      END;

      SELECT @V_DTINIC = MAX(DTINIAPURACROP)
        FROM APURACAOROP
       WHERE CDFILIAL = @V_FILIAPURA;


      IF NOT(@V_DTINIC < @P_DTINICIAL AND @V_DTINIC IS NOT NULL) BEGIN
         SET @V_DTINIC = @P_DTINICIAL;
      END;

      SELECT @V_IDLANCDTMENFIL = ISNULL(IDLANCDTMENFIL,'N')
        FROM PARAMFILIAL
       WHERE CDFILIAL = @P_CDFILIAL;

      IF ISNULL(@V_IDLANCDTMENFIL,'N') = 'S' BEGIN

         SELECT @V_NRDIAS = MAX(NRDIAS)
           FROM (SELECT NRDIASENTRFIL NRDIAS
                   FROM PARAMFILIAL
                  WHERE CDFILIAL = @P_CDFILIAL
                    AND ISNULL(IDLANCDTMENFIL,'N') = 'S'
                  UNION ALL
                 SELECT NRDIASSAIDFIL NRDIAS
                   FROM PARAMFILIAL
                  WHERE CDFILIAL = @P_CDFILIAL
                    AND ISNULL(IDLANCDTMENFIL,'N') = 'S'
                  UNION ALL
                 SELECT NRDIASAJUSFIL NRDIAS
                   FROM PARAMFILIAL
                  WHERE CDFILIAL = @P_CDFILIAL
                    AND ISNULL(IDLANCDTMENFIL,'N') = 'S') A;

      END
      ELSE BEGIN
         SELECT @V_NRDIAS = MAX(NRDIAS)
           FROM (SELECT NRDIASENTR NRDIAS
                   FROM PARAMESTOQUE
                  WHERE ISNULL(IDLANCDTMEN,'N') = 'S'
                  UNION ALL
                 SELECT NRDIASSAID NRDIAS
                   FROM PARAMESTOQUE
                  WHERE ISNULL(IDLANCDTMEN,'N') = 'S'
                  UNION ALL
                 SELECT NRDIASAJUS NRDIAS
                   FROM PARAMESTOQUE
                  WHERE ISNULL(IDLANCDTMEN,'N') = 'S')A;

      END;

      IF (@V_DTINIC >= @V_DTPROCESSA - @V_NRDIAS) BEGIN
         SET @V_DTINIC = @V_DTPROCESSA - @V_NRDIAS;
      END;


      IF @V_IDTPAPURACAO = '2' BEGIN
         DECLARE C_LANCROPFILI CURSOR FOR
            SELECT CDFILIAL, NRROPFILIAL, NRLANCROP
            FROM LANCROPFILIAL
            WHERE CDFILIAL     =  @P_CDFILIAL       AND
                  DTLANCROP  >= @V_DTINIC
         OPEN C_LANCROPFILI;
         FETCH NEXT FROM C_LANCROPFILI  INTO @V_DELCDFILIAL, @V_NRROPFIL, @V_DELNRLANCROP;
         WHILE (@@FETCH_STATUS = 0)   BEGIN
            DELETE ITRELACITROP
            WHERE CDFILIAL    = @P_CDFILIAL  AND
                  NRLANCROP   = @V_DELNRLANCROP AND
                  NRROPFILIAL = @V_NRROPFIL;

            DELETE ITLANCROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL  AND
                  NRLANCROP   = @V_DELNRLANCROP AND
                  NRROPFILIAL =  @V_NRROPFIL;

            DELETE LANCROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL  AND
                  NRLANCROP   = @V_DELNRLANCROP AND
                  NRROPFILIAL =  @V_NRROPFIL;

            FETCH NEXT FROM C_LANCROPFILI  INTO @V_DELCDFILIAL, @V_NRROPFIL, @V_DELNRLANCROP;
         END;
         CLOSE C_LANCROPFILI;
         DEALLOCATE C_LANCROPFILI;


         DECLARE C_ROPFILI CURSOR FOR
            SELECT NRROPFILIAL
            FROM ROPFILIAL
            WHERE CDFILIAL     = @P_CDFILIAL       AND
                  DTFILIALROP  >= @V_DTINIC;
         OPEN C_ROPFILI;
         FETCH NEXT FROM C_ROPFILI INTO @V_NRROPFIL;

         WHILE (@@FETCH_STATUS = 0)   BEGIN
            DELETE ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL  AND
                  NRROPFILIAL = @V_NRROPFIL;


            FETCH NEXT FROM C_ROPFILI  INTO @V_NRROPFIL;
         END;
         CLOSE C_ROPFILI;
         DEALLOCATE C_ROPFILI;
      END;
   END
   ELSE BEGIN
      SET @V_DTINIC =  @P_DTINICIAL;
   END;

   /*Insere corpo do resultado operacional da filial de acordo com o perodo solicitado*/

   SET @V_DTFILIALROP = @V_DTINIC;

   WHILE (@V_DTFILIALROP <= @P_DTFINAL) BEGIN

      SET @V_NRROPDIF = 0;
      SET @V_STR = 'RESULTOPER' + @P_CDFILIAL;

      WHILE (@V_NRROPDIF = 0) BEGIN
         EXEC TEKNISA.NOVO_CODIGO @V_STR, @P_SEQUENCIAL = @V_NRROPFILIAL OUTPUT;
         SET @V_NRROPFILIAL = SUBSTRING(@V_NRROPFILIAL, 11, 10);
         SET @V_NRROPFILINI = @V_NRROPFILIAL;

         SELECT @V_CDFILIALBO = MAX(CDFILIAL)
           FROM ROPFILIAL
          WHERE CDFILIAL = @P_CDFILIAL AND
                NRROPFILIAL = @V_NRROPFILIAL;

         IF @V_CDFILIALBO IS NULL BEGIN
            SET @V_NRROPDIF = 1;
         END;
      END;

      /*Insere corpo do resultado operacional da filial de acordo com o perodo solicitado*/
      INSERT INTO ROPFILIAL
         (CDFILIAL, NRROPFILIAL, DTINICROP, DTFINALROP, DTGERAROP, DTFILIALROP)
      VALUES
         (@P_CDFILIAL, @V_NRROPFILIAL, @V_DTINIC, @P_DTFINAL, GETDATE(), @V_DTFILIALROP);

      /*Grava Posio Incial e Final para cada dia apurado*/
      /*Inventrio Inicial*/

      IF @V_IDINVINICROP = 'S' BEGIN
         SET @V_NRITLANCROP = '00000';
         IF @V_NRTIPOCUSTO IN (40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,57,58,59,60,61,62) BEGIN
            DECLARE C_INVINICIAL CURSOR FOR
               SELECT AN.CDGRUPPROD, AN.CDSUBGRPROD, SUM(QTESTDIACON) AS QTESTDIACON, SUM(VRESTDIACON) VRESTDIACON
                 FROM GRUPPROD GR, SUBGRUPPROD SG,
                      PARFILIALROP PA, PRSUBGRPROD AN,  PRODUTO A,
                  (SELECT CDPRODUTO, QTESTDIACON,
                          ISNULL(TEKNISA.CUSTO_PRODUTO(P.CDFILIAL, P.CDPRODUTO, @V_NRTIPOCUSTO, @V_DTINIC, GETDATE()) * QTESTDIACON,0) AS VRESTDIACON
                     FROM POSESTCONS P
                    WHERE (P.CDFILIAL   = @P_CDFILIAL)              AND
                          (QTESTDIACON <> 0  OR VRESTDIACON <> 0)   AND
                          (P.DTPOSESTCON = (SELECT Max(DTPOSESTCON)
                                              FROM POSESTCONS C
                                             WHERE (C.CDFILIAL     = @P_CDFILIAL)     AND
                                                 (C.CDPRODUTO    = P.CDPRODUTO)    AND
                                                 (C.DTPOSESTCON <= @V_DTFILIALROP))) ) P
                WHERE
                   (CDFILISUBGR     = @V_CDFILISUBGR)         AND
                   (PA.CDFILIAL     = @V_FILIALPAR)           AND
                   (PA.CDGRUPPROD   = GR.CDGRUPPROD)         AND
                   (GR.CDGRUPPROD   = SG.CDGRUPPROD)         AND
                   (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)        AND
                   (P.CDPRODUTO     = AN.CDPRODUTO)          AND
                   (SG.CDGRUPPROD   = AN.CDGRUPPROD)         AND
                   (P.CDPRODUTO     = A.CDPRODUTO)           AND
                   (A.CDPRODUTO     = A.CDPRODESTO)
               GROUP BY AN.CDGRUPPROD, AN.CDSUBGRPROD
               ORDER BY AN.CDGRUPPROD, AN.CDSUBGRPROD DESC;

            OPEN C_INVINICIAL;
            FETCH NEXT FROM C_INVINICIAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_QTESTOQDIA, @V_VRESTOQDIA;
            WHILE (@@FETCH_STATUS = 0)   BEGIN
                  SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

                  /*Inclui Inventario Inicial*/
                  INSERT INTO LANCROPFILIAL
                     (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                      NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
                  VALUES
                     (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTFILIALROP, 'II', '',
                      '',  '', '', @P_CDFILIAL,'', @V_CDFILCENTROP);


                  /*Inclui Item do Lanamento*/
                  SET @V_NRITLANCROP = '00001';

                  INSERT INTO ITLANCROPFILIAL
                     (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                      NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP, VRITEMLANCROP,
                      CDGRUPPRODROP, CDSUBGRPRODROP)
                  VALUES
                     (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @P_CDFILIAL, '',
                      '', @V_CDSUBGRPROD,  @V_QTESTOQDIA, @V_VRESTOQDIA,
                      @V_CDGRUPPROD, @V_CDSUBGRPROD);

                  SET @V_CONSUMO = @V_CONSUMO + @V_VRESTOQDIA;
               FETCH NEXT FROM C_INVINICIAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_QTESTOQDIA, @V_VRESTOQDIA;
            END;
            CLOSE C_INVINICIAL;
            DEALLOCATE C_INVINICIAL;
         END
         ELSE BEGIN
            DECLARE C_INVINICIAL CURSOR FOR
               SELECT AN.CDGRUPPROD, AN.CDSUBGRPROD, SUM(VRESTDIACON) AS VRESTDIACON, SUM(QTESTDIACON) AS QTESTDIACON
                 FROM GRUPPROD GR, SUBGRUPPROD SG,
                      PARFILIALROP PA, PRSUBGRPROD AN,  PRODUTO A,
                  (SELECT CDPRODUTO, QTESTDIACON, VRESTDIACON
                     FROM POSESTCONS P
                    WHERE (P.CDFILIAL   = @P_CDFILIAL)              AND
                          (QTESTDIACON <> 0  OR VRESTDIACON <> 0)   AND
                          (P.DTPOSESTCON = (SELECT Max(DTPOSESTCON)
                                              FROM POSESTCONS C
                                             WHERE (C.CDFILIAL     = @P_CDFILIAL)     AND
                                                   (C.CDPRODUTO    = P.CDPRODUTO)    AND
                                                   (C.DTPOSESTCON <= @V_DTFILIALROP)))) P
                WHERE
                   (CDFILISUBGR     = @V_CDFILISUBGR)         AND
                   (PA.CDFILIAL     = @V_FILIALPAR)           AND
                   (PA.CDGRUPPROD   = GR.CDGRUPPROD)         AND
                   (GR.CDGRUPPROD   = SG.CDGRUPPROD)         AND
                   (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)        AND
                   (P.CDPRODUTO     = AN.CDPRODUTO)          AND
                   (SG.CDGRUPPROD   = AN.CDGRUPPROD)         AND
                   (P.CDPRODUTO     = A.CDPRODUTO)           AND
                   (A.CDPRODUTO     = A.CDPRODESTO)
               GROUP BY AN.CDGRUPPROD, AN.CDSUBGRPROD
               ORDER BY AN.CDGRUPPROD, AN.CDSUBGRPROD DESC;

            OPEN C_INVINICIAL;
            FETCH NEXT FROM C_INVINICIAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRESTOQDIA, @V_QTESTOQDIA;
            WHILE (@@FETCH_STATUS = 0)   BEGIN
                  SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

                  /*Inclui Inventario Inicial*/
                  INSERT INTO LANCROPFILIAL
                     (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                      NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
                  VALUES
                     (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTFILIALROP, 'II', '',
                      '',  '', '', @P_CDFILIAL,'', @V_CDFILCENTROP);


                  /*Inclui Item do Lanamento*/
                  SET @V_NRITLANCROP = '00001';

                  INSERT INTO ITLANCROPFILIAL
                     (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                      NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP, VRITEMLANCROP,
                      CDGRUPPRODROP, CDSUBGRPRODROP)
                  VALUES
                     (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @P_CDFILIAL, '',
                      '', @V_CDSUBGRPROD, @V_QTESTOQDIA, @V_VRESTOQDIA,
                      @V_CDGRUPPROD, @V_CDSUBGRPROD);

                  SET @V_CONSUMO = @V_CONSUMO + @V_VRESTOQDIA;
               FETCH NEXT FROM C_INVINICIAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRESTOQDIA, @V_QTESTOQDIA;
            END;
            CLOSE C_INVINICIAL;
            DEALLOCATE C_INVINICIAL;
         END;
      END;

      /*Inventrio Final*/
      IF @V_IDINVFINAROP = 'S' BEGIN
         SET @V_NRITLANCROP = '00000';
         IF @V_NRTIPOCUSTO IN (40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,57,58,59,60,61,62) BEGIN
            DECLARE C_INVFINAL CURSOR FOR
               SELECT AN.CDGRUPPROD, AN.CDSUBGRPROD,
                      SUM(VRESTDIACON) AS VRESTDIACON, SUM(QTESTDIACON) AS QTESTDIACON
               FROM GRUPPROD GR, SUBGRUPPROD SG,
                    PARFILIALROP PA, PRSUBGRPROD AN,  PRODUTO A,
                  (SELECT CDPRODUTO, QTESTDIACON,
                          ISNULL(TEKNISA.CUSTO_PRODUTO(P.CDFILIAL, P.CDPRODUTO, @V_NRTIPOCUSTO, @V_DTINIC, GETDATE()),0) * QTESTDIACON AS VRESTDIACON
                     FROM POSESTCONS P
                    WHERE (P.CDFILIAL   = @P_CDFILIAL)              AND
                          (QTESTDIACON <> 0  OR VRESTDIACON <> 0)   AND
                          (P.DTPOSESTCON = (SELECT Max(DTPOSESTCON)
                                              FROM POSESTCONS C
                                             WHERE (C.CDFILIAL     = @P_CDFILIAL)    AND
                                                 (C.CDPRODUTO    = P.CDPRODUTO)    AND
                                                 (C.DTPOSESTCON <= @V_DTFILIALROP+1)))) P
               WHERE
                  (CDFILISUBGR     = @V_CDFILISUBGR)        AND
                  (PA.CDFILIAL     = @V_FILIALPAR)          AND
                  (PA.CDGRUPPROD   = GR.CDGRUPPROD)         AND
                  (GR.CDGRUPPROD   = SG.CDGRUPPROD)         AND
                  (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)        AND
                  (P.CDPRODUTO     = AN.CDPRODUTO)          AND
                  (SG.CDGRUPPROD   = AN.CDGRUPPROD)         AND
                  (P.CDPRODUTO     = A.CDPRODUTO)           AND
                  (A.CDPRODUTO     = A.CDPRODESTO)
              GROUP BY AN.CDGRUPPROD, AN.CDSUBGRPROD
              ORDER  BY AN.CDGRUPPROD, AN.CDSUBGRPROD DESC;
            OPEN C_INVFINAL;
            FETCH NEXT FROM C_INVFINAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRESTOQDIA, @V_QTESTOQDIA;

            WHILE (@@FETCH_STATUS = 0)   BEGIN
               /*Inclui Inventario FINAL*/
               SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

               INSERT INTO LANCROPFILIAL
                  (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                   NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
               VALUES
                  (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTFILIALROP, 'IF', '',
                   '',  '', '', @P_CDFILIAL,'', @V_CDFILCENTROP);

               /*Inclui Item do Lanamento*/
               SET @V_NRITLANCROP = '00001';

               INSERT INTO ITLANCROPFILIAL
                  (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                   NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP, VRITEMLANCROP,
                   CDGRUPPRODROP, CDSUBGRPRODROP)
               VALUES
                  (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @P_CDFILIAL, '',
                   '', @V_CDSUBGRPROD,  @V_QTESTOQDIA, @V_VRESTOQDIA,
                   @V_CDGRUPPROD, @V_CDSUBGRPROD);

               SET @V_CONSUMO = @V_CONSUMO - @V_VRESTOQDIA;
               FETCH NEXT FROM C_INVFINAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRESTOQDIA, @V_QTESTOQDIA;
            END;
            CLOSE C_INVFINAL;
            DEALLOCATE C_INVFINAL;
         END
         ELSE BEGIN
            DECLARE C_INVFINAL CURSOR FOR
               SELECT AN.CDGRUPPROD, AN.CDSUBGRPROD, SUM(VRESTDIACON) AS VRESTDIACON, SUM(QTESTDIACON) AS QTESTDIACON
               FROM GRUPPROD GR, SUBGRUPPROD SG,
                  PARFILIALROP PA, PRSUBGRPROD AN,  PRODUTO A,
                  (SELECT CDPRODUTO, QTESTDIACON, VRESTDIACON
                   FROM POSESTCONS P
                   WHERE (P.CDFILIAL   = @P_CDFILIAL)              AND
                         (QTESTDIACON <> 0  OR VRESTDIACON <> 0)   AND
                         (P.DTPOSESTCON = (SELECT Max(DTPOSESTCON)
                                           FROM POSESTCONS C
                                           WHERE (C.CDFILIAL     = @P_CDFILIAL)    AND
                                                 (C.CDPRODUTO    = P.CDPRODUTO)    AND
                                                 (C.DTPOSESTCON <= @V_DTFILIALROP+1)))) P
               WHERE
                  (CDFILISUBGR     = @V_CDFILISUBGR)        AND
                  (PA.CDFILIAL     = @V_FILIALPAR)          AND
                  (PA.CDGRUPPROD   = GR.CDGRUPPROD)         AND
                  (GR.CDGRUPPROD   = SG.CDGRUPPROD)         AND
                  (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)        AND
                  (P.CDPRODUTO     = AN.CDPRODUTO)          AND
                  (SG.CDGRUPPROD   = AN.CDGRUPPROD)         AND
                  (P.CDPRODUTO     = A.CDPRODUTO)           AND
                  (A.CDPRODUTO     = A.CDPRODESTO)
              GROUP BY AN.CDGRUPPROD, AN.CDSUBGRPROD
              ORDER  BY AN.CDGRUPPROD, AN.CDSUBGRPROD DESC;
            OPEN C_INVFINAL;
            FETCH NEXT FROM C_INVFINAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRESTOQDIA, @V_QTESTOQDIA;

            WHILE (@@FETCH_STATUS = 0)   BEGIN
               /*Inclui Inventario FINAL*/
               SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

               INSERT INTO LANCROPFILIAL
                  (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                   NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
               VALUES
                  (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTFILIALROP, 'IF', '',
                   '',  '', '', @P_CDFILIAL,'', @V_CDFILCENTROP);

               /*Inclui Item do Lanamento*/
               SET @V_NRITLANCROP = '00001';

               INSERT INTO ITLANCROPFILIAL
                  (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                   NRSEQITPRODROP, CDITEMLANCROP, QTITEMLANCROP, VRITEMLANCROP,
                   CDGRUPPRODROP, CDSUBGRPRODROP)
               VALUES
                  (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @P_CDFILIAL, '',
                   '', @V_CDSUBGRPROD,  @V_QTESTOQDIA, @V_VRESTOQDIA,
                   @V_CDGRUPPROD, @V_CDSUBGRPROD);

               SET @V_CONSUMO = @V_CONSUMO - @V_VRESTOQDIA;
               FETCH NEXT FROM C_INVFINAL INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRESTOQDIA, @V_QTESTOQDIA;
            END;
            CLOSE C_INVFINAL;
            DEALLOCATE C_INVFINAL;
         END;
      END;
      /**/
      SET @V_DTFILIALROP = @V_DTFILIALROP+1;
   END;

/* Clculo do Faturamento*/

   /*Faturamento Bruto - Notas Fiscais de sada */
   IF @V_IDFATUROP = 'FS' OR @V_IDFATUROP = 'AB' BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      DECLARE C_FATURASAIDA CURSOR FOR
         (SELECT N.CDCLIENTE,  N.CDTIPOOPER, N.NRNOTAFISC, N.CDFILIAL,
                 N.NRLANCTONF, DTENTRSAID,  N.CDSERIE,    N.IDSTATUS,
                 N.DTINIREFEFAT, N.DTFINREFEFAT,
                 CASE IDSISTEMA WHEN 'PDV' THEN N.VRPRODUTOS ELSE N.VRNOTAFISC END AS VALORTOTAL
            FROM NOTAFISCAL N, TIPOOPERACROP P
           WHERE (N.CDFILIEMIT    = @P_CDFILIAL)
             AND (N.IDENTRSAIDOP  = 'S')
             AND (N.DTENTRSAID BETWEEN @V_DTINIC AND @P_DTFINAL)
             AND (@V_FILIALPAR    = P.CDFILIAL)
             AND (N.CDTIPOOPER    = P.CDTIPOOPER)
             AND (N.IDENTRSAIDOP  = P.IDENTRSAIDOP)
             AND (P.IDTPOPERACROP = 'FS')
             AND ((N.IDSTATUS    IN ('A','E', 'P')) OR (N.IDSISTEMA = 'PDV'))
             AND (N.IDSISTEMA NOT IN ('REC','FIS') OR N.IDSISTEMA IS NULL));

      OPEN C_FATURASAIDA;
      FETCH NEXT FROM C_FATURASAIDA INTO @V_CDCLIENTE, @V_CDTIPOOPER, @V_NRNOTAFISC,
                                     @V_CDFILIAL,  @V_NRLANCTONF, @V_DTENTRSAID,
                                     @V_CDSERIE,   @V_IDSTATUS,   @V_DTINIREFEFAT,
                                     @V_DTFINREFEFAT, @V_VALORTOTAL;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

         IF @V_DTLANCROP <> @V_DTENTRSAID BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
            FROM ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  DTFILIALROP = @V_DTENTRSAID;

            SET @V_DTLANCROP   =@V_DTENTRSAID;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;

         /*Inclui Lanamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP, IDSTATUSROP,
             DTINIREFEROP,  DTFINREFEROP)
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTENTRSAID, 'FS', @V_CDCLIENTE,
             @V_CDTIPOOPER,  @V_NRNOTAFISC, @V_CDSERIE, @V_CDFILIAL,@V_NRLANCTONF, @V_CDFILCENTROP,
             @V_IDSTATUS, @V_DTINIREFEFAT, @V_DTFINREFEFAT);


         SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

         INSERT INTO ITLANCROPFILIAL
            (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
             NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
         VALUES
            (@P_CDFILIAL,   @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, @V_NRLANCTONF,
             '', '',  0, @V_VALORTOTAL);

         SET @V_NRSEQRELACIT = '00000';
         /*Imposto por Item NF */
         DECLARE C_IMPOSTO CURSOR FOR
              SELECT P.CDIMPOSTO, P.IDTRATIMPROP,
                     SUM(VRIMPOSTOIT) AS VRIMPOSTO
                FROM IMPOSTOROP P, ITEMPROIMPOS I
               WHERE (P.CDFILIAL     =  @V_FILIALPAR)
                 AND (I.CDFILIAL     =  @V_CDFILIAL)
                 AND (I.NRLANCTONF   =  @V_NRLANCTONF)
                 AND (I.CDIMPOSTO    =  P.CDIMPOSTO)
                 AND (I.NRITPROIMPOS = '1')
                 AND (IDTPIMPOSTOROP = 'FS')
               GROUP BY P.CDIMPOSTO, P.IDTRATIMPROP
               ORDER BY P.CDIMPOSTO;

         OPEN C_IMPOSTO;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDIMPOSTO, @V_IDTRATIMPROP, @V_VRIMPOSTO;
         WHILE (@@FETCH_STATUS = 0)   BEGIN
            SET @V_NRSEQRELACIT = @V_NRSEQRELACIT + 1;
/*AQUI 1*/
            INSERT INTO ITRELACITROP
               (CDFILIAL,  NRROPFILIAL, NRLANCROP, NRITLANCROP, NRSEQRELACITROP,
                CDITRELITROP, QTITRELITROP, VRITRELITROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_NRSEQRELACIT,
                @V_CDIMPOSTO, 0,@V_VRIMPOSTO);
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDIMPOSTO, @V_IDTRATIMPROP, @V_VRIMPOSTO;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;

         FETCH NEXT FROM C_FATURASAIDA INTO @V_CDCLIENTE, @V_CDTIPOOPER, @V_NRNOTAFISC,
                                            @V_CDFILIAL,  @V_NRLANCTONF, @V_DTENTRSAID,
                                            @V_CDSERIE,   @V_IDSTATUS,   @V_DTINIREFEFAT,
                                            @V_DTFINREFEFAT, @V_VALORTOTAL;

      END;
      CLOSE C_FATURASAIDA;
      DEALLOCATE C_FATURASAIDA;
   END;

      /*Faturamento Bruto - Medio De Efetivos */

   IF @V_IDFATUROP = 'FE' OR @V_IDFATUROP = 'AB' BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      SET @V_TEXT = 'APURACFATUR' + @P_CDFILIAL;

      EXEC TEKNISA.NOVO_CODIGO @V_TEXT, @P_SEQUENCIAL = @V_NRAPURREL OUTPUT, @P_QTDE = 1;

      SET @V_NRAPURREL = SUBSTRING(@V_NRAPURREL, 11, 10);


      EXEC TEKNISA.APURAC_RELGESDIRETA @P_CDFILIAL, @V_DTINIC, @P_DTFINAL, @V_NRAPURREL;

  /* Gesto Merenda  */
      SELECT @V_CDFILCENTPME = MAX(CDFILCENTPME)
        FROM FILIAL
       WHERE CDFILIAL = @P_CDFILIAL;

      DECLARE C_EFET_PME CURSOR FOR
                         SELECT E.CDFILCENTPME, E.CDFILIAL, E.CDSERVFILI, E.DTEFETCLPME,
                                E.CDCLIENTE,
                                ISNULL(SUM(E.QTCOMEFCLPME),0) AS QTCOMEFCLPME,
                                ISNULL(SUM(VRCUSPADTCAR * E.QTCOMEFCLPME),0) VRDIETFATU
                           FROM EFETCLIEPME E, SERVICOROP S, CUSTPADTCARD C
                          WHERE E.CDFILCENTPME = @V_CDFILCENTPME
                            AND E.CDFILIAL     = @P_CDFILIAL
                            AND DTEFETCLPME  BETWEEN @V_DTINIC AND @P_DTFINAL
                            AND @V_FILIALPAR    = S.CDFILIAL
                            AND IDTPSERVICOROP = 'E'
                            AND @V_IDSERVFATROP <> 'S'
                            AND E.CDSERVFILI = S.CDSERVFILI
                            AND E.CDFILCENTPME = C.CDFILCENTPME
                            AND E.CDSERVFILI = C.CDSERVFILI
                            AND S.CDSERVFILI = C.CDSERVFILI
                          GROUP BY E.CDFILCENTPME, E.CDFILIAL, E.CDSERVFILI,
                                   E.DTEFETCLPME, E.CDCLIENTE

                         UNION ALL

                         SELECT E.CDFILCENTPME, E.CDFILIAL, E.CDSERVFILI, E.DTEFETCLPME,
                                E.CDCLIENTE,
                                ISNULL(SUM(E.QTCOMEFCLPME),0) AS QTCOMEFCLPME,
                                ISNULL(SUM(VRCUSPADTCAR * E.QTCOMEFCLPME),0) VRDIETFATU
                           FROM EFETCLIEPME E, CUSTPADTCARD C
                          WHERE E.CDFILCENTPME = @V_CDFILCENTPME
                            AND E.CDFILIAL     = @P_CDFILIAL
                            AND DTEFETCLPME  BETWEEN @V_DTINIC AND @P_DTFINAL
                            AND @V_IDSERVFATROP = 'S'
                            AND E.CDFILCENTPME = C.CDFILCENTPME
                            AND E.CDSERVFILI = C.CDSERVFILI
                          GROUP BY E.CDFILCENTPME, E.CDFILIAL, E.CDSERVFILI,
                                   E.DTEFETCLPME, E.CDCLIENTE
      OPEN C_EFET_PME;
      FETCH NEXT FROM C_EFET_PME INTO @V_CDFILCENTPME, @V_CDFILIAL,@V_CDSERVFILI,
                                      @V_DTEFETCLPME, @V_CDCLIENTE,
                                      @V_QUANTIDADE, @V_VALORTOTAL;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTEFETCLPME BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
              FROM ROPFILIAL
             WHERE CDFILIAL    = @P_CDFILIAL
               AND DTFILIALROP = @V_DTEFETCLPME;


            SET @V_DTLANCROP   = @V_DTEFETCLPME;
            IF @V_NRROPFILIAL IS NULL BEGIN
              SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;

         /*Inclui Lanamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTEFETCLPME, 'FE', @V_CDCLIENTE,
             '',  '', '', @V_CDFILIAL, '', @V_CDFILCENTROP);


         /*Inclui Item do Lanamento*/
         SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

         INSERT INTO ITLANCROPFILIAL
            (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
             NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
         VALUES
            (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, '',
             '', @V_CDSERVFILI, @V_QUANTIDADE, @V_VALORTOTAL);

         EXEC TEKNISA.IMPOSTOROP_RELGESPME @P_CDFILIAL, @V_DTINIC, @P_DTFINAL, @V_NRROPFILIAL,
                                           @V_NRLANCROP,@V_NRITLANCROP, @V_CDCLIENTE,
                                           @V_DTEFETCLPME, @V_CDSERVFILI;


         FETCH NEXT FROM C_EFET_PME INTO @V_CDFILCENTPME, @V_CDFILIAL,@V_CDSERVFILI,
                                      @V_DTEFETCLPME, @V_CDCLIENTE,
                                      @V_QUANTIDADE, @V_VALORTOTAL;

      END;
      CLOSE C_EFET_PME;
      DEALLOCATE C_EFET_PME;

      /* Gestao Hospitalar  */
      DECLARE C_EFET_HOSP CURSOR FOR
                          SELECT E.CDFILIAL, E.DTEFETDIET, E.CDSERVFILI,   E.CDCLIENTE,
                                 ISNULL(SUM(TEKNISA.CALCVALRSERV(E.CDFILIAL, E.CDCLIENTE, E.CDSERVFILI, DTEFETDIET, NULL) * E.QTCOMEFETDIE),0) AS VRDIETFATU,
                                 ISNULL(SUM(E.QTCOMEFETDIE),0) AS QTCOMEFETDIE
                            FROM EFETDIET E, SERVICOROP S
                           WHERE E.CDFILIAL     = @P_CDFILIAL
                             AND E.CDSERVFILI   = S.CDSERVFILI
                             AND E.DTEFETDIET BETWEEN @V_DTINIC AND @P_DTFINAL
                             AND @V_FILIALPAR    = S.CDFILIAL
                             AND IDTPSERVICOROP = 'E'
                             AND @V_IDSERVFATROP <> 'S'
                           GROUP BY E.CDFILIAL, E.DTEFETDIET, E.CDSERVFILI,   E.CDCLIENTE

                           UNION ALL

                          SELECT E.CDFILIAL, E.DTEFETDIET, E.CDSERVFILI,   E.CDCLIENTE,
                                 ISNULL(SUM(TEKNISA.CALCVALRSERV(E.CDFILIAL, E.CDCLIENTE, E.CDSERVFILI, DTEFETDIET, NULL) * E.QTCOMEFETDIE),0) AS VRDIETFATU,
                                 ISNULL(SUM(E.QTCOMEFETDIE),0) AS QTCOMEFETDIE
                            FROM EFETDIET E
                           WHERE E.CDFILIAL     = @P_CDFILIAL
                             AND E.DTEFETDIET BETWEEN @V_DTINIC AND @P_DTFINAL
                             AND @V_IDSERVFATROP <> 'S'
                           GROUP BY E.CDFILIAL, E.DTEFETDIET, E.CDSERVFILI,   E.CDCLIENTE

      OPEN C_EFET_HOSP;
      FETCH NEXT FROM C_EFET_HOSP INTO @V_CDFILIAL,@V_DTEFETDIET, @V_CDSERVFILI,
                                       @V_CDCLIENTE, @V_VALORTOTAL, @V_QUANTIDADE;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTEFETDIET BEGIN
            SET @V_NRROPFILIAL  = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
              FROM ROPFILIAL
             WHERE CDFILIAL    = @P_CDFILIAL
               AND DTFILIALROP = @V_DTEFETDIET;


            SET @V_DTLANCROP   = @V_DTEFETDIET;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;

         /*Inclui Lanamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTEFETDIET, 'FE', @V_CDCLIENTE,
             '',  '', '', @V_CDFILIAL, '', @V_CDFILCENTROP);


         /*Inclui Item do Lanamento*/
         SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

         INSERT INTO ITLANCROPFILIAL
            (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
             NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
         VALUES
            (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, '',
             '', @V_CDSERVFILI,  @V_QUANTIDADE, @V_VALORTOTAL);

         EXEC IMPOSTOROP_RELGESHOSP @P_CDFILIAL, @V_DTINIC, @P_DTFINAL, @V_NRROPFILIAL, @V_NRLANCROP,
                                            @V_NRITLANCROP, @V_CDCLIENTE, @V_DTEFETDIET, @V_CDSERVFILI;


         FETCH NEXT FROM C_EFET_HOSP INTO @V_CDFILIAL,@V_DTEFETDIET, @V_CDSERVFILI,
                                       @V_CDCLIENTE, @V_VALORTOTAL, @V_QUANTIDADE;

      END;
      CLOSE C_EFET_HOSP;
      DEALLOCATE C_EFET_HOSP;

      SET @V_NRITLANCROP = '00000';
      DECLARE C_EFETIVOS CURSOR FOR
         SELECT DISTINCT T.CDSERVFILIAPGD, CDCLIENTEAPGD, DTAPURACFATGD,
              ISNULL(SUM(T.NREFETIVOSAPGD),0) AS QUANTIDADE,
              ISNULL(SUM(T.VRPRECUNITAPGD * T.NREFETIVOSAPGD),0) AS VALORTOTAL
         FROM TRAB_APURAC_GD T, SERVICOROP S
         WHERE (T.CDFILIALAPGD   = @P_CDFILIAL)                               AND
               (T.NRAPURACGD     = @V_NRAPURREL)                              AND
               (T.DTAPURACFATGD  BETWEEN @V_DTINIC AND @P_DTFINAL)  AND
               (@V_FILIALPAR      = S.CDFILIAL)                               AND
               (T.CDSERVFILIAPGD = S.CDSERVFILI)                             AND
               (IDTPSERVICOROP   = 'E')                                      AND
               (@V_IDSERVFATROP   <> 'S')
        GROUP BY  T.CDSERVFILIAPGD, DTAPURACFATGD, CDCLIENTEAPGD

        UNION ALL

        SELECT DISTINCT CDSERVFILIAPGD, CDCLIENTEAPGD, DTAPURACFATGD,
               ISNULL(SUM(T.NREFETIVOSAPGD),0) AS QUANTIDADE,
               ISNULL(SUM(T.VRPRECUNITAPGD * T.NREFETIVOSAPGD),0) AS VALORTOTAL
        FROM TRAB_APURAC_GD T
        WHERE (T.CDFILIALAPGD   = @P_CDFILIAL)                               AND
              (T.NRAPURACGD     = @V_NRAPURREL)                              AND
              (T.DTAPURACFATGD  BETWEEN @V_DTINIC AND @P_DTFINAL)  AND
              (@V_IDSERVFATROP   = 'S')
        GROUP BY  T.CDSERVFILIAPGD, DTAPURACFATGD, CDCLIENTEAPGD

      OPEN C_EFETIVOS;
      FETCH NEXT FROM C_EFETIVOS INTO @V_CDSERVFILIAPGD, @V_CDCLIENTEAPGD, @V_DTAPURACFATGD,
                                      @V_QUANTIDADE, @V_VALORTOTAL;
      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTAPURACFATGD BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
            FROM ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  DTFILIALROP = @V_DTAPURACFATGD;

            SET @V_DTLANCROP  = @V_DTAPURACFATGD;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;
         /*Inclui Lanamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTAPURACFATGD, 'FE', @V_CDCLIENTEAPGD,
             '',  '', '', @V_CDFILFATAPGD, @V_NRAPUFATAPGD, @V_CDFILCENTROP);


            /*Inclui Item do Lanamento*/
         SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

         INSERT INTO ITLANCROPFILIAL
            (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
             NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
         VALUES
            (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILFATAPGD, @V_NRAPUFATAPGD,
             '', @V_CDSERVFILIAPGD,  @V_QUANTIDADE, @V_VALORTOTAL);

         EXEC IMPOSTOROP_RELGESDIRETA @P_CDFILIAL, @V_DTINIC, @P_DTFINAL, @V_NRAPURREL,
                                 @V_NRROPFILIAL,  @V_NRLANCROP, @V_NRITLANCROP, @V_CDCLIENTEAPGD,
                                 @V_DTAPURACFATGD, @V_CDSERVFILIAPGD;

         FETCH NEXT FROM C_EFETIVOS INTO @V_CDSERVFILIAPGD, @V_CDCLIENTEAPGD, @V_DTAPURACFATGD,
                                       @V_QUANTIDADE, @V_VALORTOTAL;
      END;
      CLOSE C_EFETIVOS;
      DEALLOCATE C_EFETIVOS;

      DELETE FROM TRAB_APURAC_GD
      WHERE
        (CDFILIALAPGD   = @P_CDFILIAL)                               AND
        (NRAPURACGD     = @V_NRAPURREL)                              AND
        (DTAPURACFATGD  BETWEEN @V_DTINIC AND @P_DTFINAL);
   END;

/* Clculo do Consumo*/

   /*Consumo Compra*/


   IF @V_IDCOMPRAROP = 'S' BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      DECLARE C_CONSCOMPRA CURSOR FOR
           SELECT N.CDCLIENTE,  N.CDTIPOOPER, N.NRNOTAFISC, N.CDFILIAL,
                  N.NRLANCTONF, DTENTRSAID,   N.CDSERIE, N.CDFORNECED,
                  N.IDSTATUS,   N.DTINIREFEFAT, N.DTFINREFEFAT, P.NUMERORE
             FROM LANCTOESTOQ L, NOTAFISCAL N
             LEFT JOIN (SELECT NRNUMERNF AS NUMERORE, CDFILIAL, DTNUMERNF AS DATARE
                          FROM NUMERORNF
                         WHERE CDFILIAL = @P_CDFILIAL
                           AND IDENTRSAID = 'E'
                           AND DTNUMERNF BETWEEN @V_DTINIC AND @P_DTFINAL) P
              ON (N.CDFILIAL      = P.CDFILIAL)
             AND (N.DTENTRSAID    = P.DATARE)
            WHERE (N.CDFILIRECE   = @P_CDFILIAL)
              AND (N.IDENTRSAIDOP = 'E')
              AND (N.IDSTATUS    <> 'C')
              AND (N.CDFILIAL      = L.CDFILIAL)
              AND (N.NRLANCTONF    = L.NRLANCTONF)
              AND (N.IDSISTEMA NOT IN ('PAG','REC','FIS','CMP') OR N.IDSISTEMA IS NULL)
              AND (N.DTENTRSAID BETWEEN @V_DTINIC AND @P_DTFINAL)
            ORDER BY DTENTRSAID;

      OPEN C_CONSCOMPRA;
      FETCH NEXT FROM C_CONSCOMPRA INTO @V_CDCLIENTE,  @V_CDTIPOOPER, @V_NRNOTAFISC, @V_CDFILIAL,
                                        @V_NRLANCTONF, @V_DTENTRSAID, @V_CDSERIE, @V_CDFORNECED,
                                        @V_IDSTATUS,   @V_DTINIREFEFAT, @V_DTFINREFEFAT, @V_NUMERORE;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTENTRSAID BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
              FROM ROPFILIAL
             WHERE CDFILIAL    = @P_CDFILIAL AND
                   DTFILIALROP = @V_DTENTRSAID;

            SET @V_DTLANCROP  = @V_DTENTRSAID;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;
         /*Inclui Lanamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP, IDSTATUSROP,
             DTINIREFEROP,  DTFINREFEROP, NUMEROREROP)
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTENTRSAID, 'CC', @V_CDFORNECED,
             @V_CDTIPOOPER,  @V_NRNOTAFISC, @V_CDSERIE, @V_CDFILIAL, @V_NRLANCTONF,   @V_CDFILCENTROP,
             @V_IDSTATUS, @V_DTINIREFEFAT, @V_DTFINREFEFAT, @V_NUMERORE);

         SET @V_NRITLANCROP   = '00000';
         SET @V_NRSEQRELACIT  = '00000';
         SET @V_PRODUTO       = '';
         SET @V_NRSEQIT       = 'N';
         SET @V_PRIIMP        = 0;
         DECLARE C_ITCONSCOMPRA CURSOR FOR
                                SELECT
                                    AN.CDSUBGRPROD, AN.CDGRUPPROD,
                                    SUM(I.VRBRUTITEM) AS VALORTOTAL,
                                    SUM(I.QTITEMPROD) AS QUANTIDADE
                                  FROM
                                     ITEMPRODUTO I, GRUPPROD GR,
                                     SUBGRUPPROD SG, PARFILIALROP P,
                                     PRSUBGRPROD AN, PRODFILI PR
                                  WHERE
                                     (I.CDFILIAL      = @V_CDFILIAL)      AND
                                     (I.NRLANCTONF    = @V_NRLANCTONF)    AND
                                     (P.CDFILIAL      = @V_FILIALPAR)                AND
                                     (CDFILISUBGR     = @V_CDFILISUBGR)              AND
                                     (P.CDGRUPPROD    = GR.CDGRUPPROD)              AND
                                     (GR.CDGRUPPROD   = SG.CDGRUPPROD)              AND
                                     (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)             AND
                                     (I.CDPRODUTO     = AN.CDPRODUTO)               AND
                                     (SG.CDGRUPPROD   = AN.CDGRUPPROD)              AND
                                     (PR.CDFILIAL     = @P_CDFILIAL)                 AND
                                     (PR.CDPRODUTO    = I.CDPRODMOVI)                AND
                                     (ISNULL(PR.IDCNTRESTOQ,'S')  = 'S')
                                  GROUP BY AN.CDSUBGRPROD, AN.CDGRUPPROD
                                  ORDER BY AN.CDSUBGRPROD, AN.CDGRUPPROD;

         OPEN C_ITCONSCOMPRA;
         FETCH NEXT FROM C_ITCONSCOMPRA INTO @V_CDSUBGRPROD,@V_CDGRUPPROD,
                                             @V_VALORTOTAL, @V_QUANTIDADE;
         WHILE (@@FETCH_STATUS = 0)  BEGIN
            /*Inclui Item do Lanamento*/
            IF (ISNULL(@V_PRODUTO,'N') <> @V_CDSUBGRPROD)BEGIN

               SELECT @V_VRCUSTLOGLAN = SUM(VRCUSTLOGLAN),
                      @V_VRSEGULOGLAN = SUM(VRSEGULOGLAN)
                 FROM GRUPPROD GR, SUBGRUPPROD SG, PARFILIALROP P,
                      PRSUBGRPROD AN, LANCTOESTOQ L,
                      ITLANCTOEST IT, PRODFILI PR
                 WHERE
                    (IT.CDFILIAL     = @V_CDFILIAL)      AND
                    (IT.NRLANCESTQ   = @V_NRLANCTONF)    AND
                    (P.CDFILIAL      = @V_FILIALPAR)     AND
                    (CDFILISUBGR     = @V_CDFILISUBGR)   AND
                    (AN.CDSUBGRPROD  = @V_CDSUBGRPROD)   AND
                    (P.CDGRUPPROD    = GR.CDGRUPPROD)    AND
                    (GR.CDGRUPPROD   = SG.CDGRUPPROD)    AND
                    (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)   AND
                    (IT.CDPRODUTO    = AN.CDPRODUTO)     AND
                    (SG.CDGRUPPROD   = AN.CDGRUPPROD)    AND
                    (L.NRLANCTONF    = @V_NRLANCTONF)    AND
                    (L.CDFILIAL      = IT.CDFILIAL)      AND
                    (L.NRLANCESTQ    = IT.NRLANCESTQ)    AND
                    (PR.CDFILIAL     = @P_CDFILIAL)      AND
                    (PR.CDPRODUTO    = IT.CDPRODMOVI)    AND
                    (ISNULL(PR.IDCNTRESTOQ,'S')  = 'S')  AND
                    (ISNULL(IT.IDEVOLESTOQ, 'S') = 'S');



               SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

               SET @V_PRODUTO     = @V_CDSUBGRPROD;
               /*SET @V_NRSEQIT     = @V_NRSEQITPROD;*/

               INSERT INTO ITLANCROPFILIAL
                  (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                   NRSEQITPRODROP, CDITEMLANCROP, QTITEMLANCROP, VRITEMLANCROP,
                   CDGRUPPRODROP, CDSUBGRPRODROP, VRCUSTOLOGITROP, VRCUSTSEGPROD)
               VALUES

                  (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, @V_NRLANCTONF,
                   @V_NRSEQITPROD, @V_CDSUBGRPROD,  @V_QUANTIDADE, @V_VALORTOTAL,
                   @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN);

               SET @V_CONSUMO = @V_CONSUMO + @V_VALORTOTAL;
            END;
            IF @V_PRIIMP = 0 BEGIN
               DECLARE C_IMPOSTOCC CURSOR FOR
                  SELECT R.CDIMPOSTO, SUM(VRIMPOSTOIT) AS VALORIMPOSTO
                    FROM IMPOSTOROP R, ITEMPROIMPOS T, ITEMPRODUTO I
                   WHERE (I.CDFILIAL     = @V_CDFILIAL)
                     AND (I.NRLANCTONF   = @V_NRLANCTONF)
                     AND (I.CDFILIAL     = T.CDFILIAL)
                     AND (I.NRLANCTONF   = T.NRLANCTONF)
                     AND (I.NRSEQITPROD  = T.NRSEQITPROD)
                     AND (T.NRITPROIMPOS = '1')
                     AND (T.CDIMPOSTO    = R.CDIMPOSTO)
                     AND (R.CDFILIAL     = @V_FILIALPAR)
                     AND (R.IDTPIMPOSTOROP = 'CC')
                   GROUP BY R.CDIMPOSTO;

               OPEN C_IMPOSTOCC;
               FETCH NEXT FROM C_IMPOSTOCC INTO @V_CDPRODUTO, @V_VRIMPOSTO;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_NRSEQRELACIT = @V_NRSEQRELACIT + 1;

                  INSERT INTO ITRELACITROP
                   (CDFILIAL,  NRROPFILIAL, NRLANCROP, NRITLANCROP, NRSEQRELACITROP,
                    CDITRELITROP, QTITRELITROP, VRITRELITROP)
                   VALUES
                   (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_NRSEQRELACIT,
                    @V_CDPRODUTO, 0, @V_VRIMPOSTO)

                  SET @V_PRIIMP = 1;
                  FETCH NEXT FROM C_IMPOSTOCC INTO @V_CDPRODUTO, @V_VRIMPOSTO;

               END;
               CLOSE C_IMPOSTOCC ;
               DEALLOCATE C_IMPOSTOCC;
            END;
            FETCH NEXT FROM C_ITCONSCOMPRA INTO @V_CDSUBGRPROD,@V_CDGRUPPROD,
                                             @V_VALORTOTAL, @V_QUANTIDADE;


         END;
         CLOSE C_ITCONSCOMPRA;
         DEALLOCATE C_ITCONSCOMPRA;

         FETCH NEXT FROM C_CONSCOMPRA INTO @V_CDCLIENTE,  @V_CDTIPOOPER, @V_NRNOTAFISC, @V_CDFILIAL,
                                           @V_NRLANCTONF, @V_DTENTRSAID, @V_CDSERIE, @V_CDFORNECED,
                                           @V_IDSTATUS,   @V_DTINIREFEFAT, @V_DTFINREFEFAT, @V_NUMERORE;

      END;
      CLOSE C_CONSCOMPRA;
      DEALLOCATE C_CONSCOMPRA;
   END;
      /*Consumo Sada*/

   IF @V_IDNFSAIDAROP = 'S' BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      DECLARE C_CONSSAIDA CURSOR FOR
         SELECT N.CDCLIENTE,  N.CDTIPOOPER, N.NRNOTAFISC, N.CDFILIAL,
                N.NRLANCTONF, DTENTRSAID,   N.CDSERIE, N.CDFORNECED,
                N.IDSTATUS,   N.DTINIREFEFAT, N.DTFINREFEFAT, P.NUMERORE
           FROM LANCTOESTOQ L, NOTAFISCAL N
           LEFT JOIN (SELECT NRNUMERNF AS NUMERORE, CDFILIAL, DTNUMERNF AS DATARE
                       FROM NUMERORNF
                      WHERE CDFILIAL = @P_CDFILIAL
                        AND IDENTRSAID = 'S'
                        AND DTNUMERNF BETWEEN @V_DTINIC AND @P_DTFINAL) P
            ON (N.CDFILIAL      = P.CDFILIAL)
           AND (N.DTENTRSAID    = P.DATARE)
         WHERE (N.CDFILIEMIT    = @P_CDFILIAL)
           AND (N.IDENTRSAIDOP  = 'S')
           AND (N.CDFILIAL      = L.CDFILIAL)
           AND (N.NRLANCTONF    = L.NRLANCTONF)
           AND (N.IDSTATUS     <> 'C')
           AND (N.IDSISTEMA NOT IN ('PAG','REC','FIS','CMP')  OR N.IDSISTEMA IS NULL)
           AND (N.DTENTRSAID BETWEEN @V_DTINIC AND @P_DTFINAL) ;

      OPEN C_CONSSAIDA;
      FETCH NEXT FROM C_CONSSAIDA INTO @V_CDCLIENTE,  @V_CDTIPOOPER, @V_NRNOTAFISC, @V_CDFILIAL,
                                       @V_NRLANCTONF, @V_DTENTRSAID, @V_CDSERIE, @V_CDFORNECED,
                                       @V_IDSTATUS,   @V_DTINIREFEFAT, @V_DTFINREFEFAT, @V_NUMERORE;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTENTRSAID BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
            FROM ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  DTFILIALROP = @V_DTENTRSAID;

            SET @V_DTLANCROP  = @V_DTENTRSAID;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;
         /*Inclui Lanamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP, IDSTATUSROP,
             DTINIREFEROP,  DTFINREFEROP, NUMEROREROP  )
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTENTRSAID, 'CS', @V_CDFORNECED,
             @V_CDTIPOOPER,  @V_NRNOTAFISC, @V_CDSERIE, @V_CDFILIAL, @V_NRLANCTONF, @V_CDFILCENTROP,
             @V_IDSTATUS, @V_DTINIREFEFAT,  @V_DTFINREFEFAT, @V_NUMERORE);

         SET @V_NRITLANCROP  = '00000';
         SET @V_NRSEQRELACIT = '00000';
         SET @V_PRODUTO      = 'N';
         SET @V_NRSEQIT      = 'N';

         SELECT @V_CDFILIALIT  = MAX(CDFILIALIT),
                @V_NRLANCTONFIT = MAX(NRLANCTONFIT)
         FROM ITEMNOTAFISC
         WHERE CDFILIAL = @V_CDFILIAL
         AND NRLANCTONF = @V_NRLANCTONF;

         SET @V_PRIIMP       = 0;
         DECLARE C_ITCONSSAIDA CURSOR FOR
            SELECT
              AN.CDSUBGRPROD, AN.CDGRUPPROD,
              SUM(I.VRBRUTITEM) AS VALORTOTAL,
              SUM(I.QTITEMPROD) AS QUANTIDADE
            FROM
                 GRUPPROD GR,
                 SUBGRUPPROD SG, PARFILIALROP P, PRSUBGRPROD AN, LANCTOESTOQ L,
                 ITEMPRODUTO I
            WHERE (I.CDFILIAL      = @V_CDFILIAL)
              AND (I.NRLANCTONF    = @V_NRLANCTONF)
              AND (P.CDFILIAL      = @V_FILIALPAR)
              AND (CDFILISUBGR     = @V_CDFILISUBGR)
              AND (P.CDGRUPPROD    = GR.CDGRUPPROD)
              AND (GR.CDGRUPPROD   = SG.CDGRUPPROD)
              AND (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)
              AND (I.CDPRODUTO     = AN.CDPRODUTO)
              AND (SG.CDGRUPPROD   = AN.CDGRUPPROD)
              AND (L.CDFILIAL       = @V_CDFILIAL)
              AND (L.NRLANCTONF     = @V_NRLANCTONF)
              AND (I.CDPRODMOVI   = (SELECT DISTINCT IT.CDPRODMOVI
                                        FROM ITLANCTOEST IT
                                       WHERE L.CDFILIAL   = IT.CDFILIAL
                                         AND L.NRLANCESTQ = IT.NRLANCESTQ
                                         AND I.CDPRODMOVI = IT.CDPRODMOVI
                                         AND ISNULL(IDEVOLESTOQ, 'S') = 'S'))
            GROUP BY AN.CDSUBGRPROD, AN.CDGRUPPROD
            ORDER BY AN.CDSUBGRPROD, AN.CDGRUPPROD;

          OPEN C_ITCONSSAIDA;
          FETCH NEXT FROM C_ITCONSSAIDA INTO @V_CDSUBGRPROD, @V_CDGRUPPROD,
                                             @V_VALORTOTAL,  @V_QUANTIDADE;

          WHILE (@@FETCH_STATUS = 0) BEGIN
             IF (ISNULL(@V_PRODUTO,'N') <> @V_CDSUBGRPROD)BEGIN
                  /*Inclui Item do Lanamento*/
                SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

                SET @V_PRODUTO = @V_CDSUBGRPROD;
                SET @V_NRSEQIT = @V_NRSEQITPROD;


                INSERT INTO ITLANCROPFILIAL
                   (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                    NRSEQITPRODROP, CDITEMLANCROP, QTITEMLANCROP, VRITEMLANCROP,
                    CDGRUPPRODROP, CDSUBGRPRODROP)
                VALUES
                   (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP,
                    @V_CDFILIAL, @V_NRLANCTONF,
                    @V_NRSEQITPROD, @V_CDSUBGRPROD, @V_QUANTIDADE, @V_VALORTOTAL,
                    @V_CDGRUPPROD, @V_CDSUBGRPROD);

                SET @V_CONSUMO = @V_CONSUMO - @V_VALORTOTAL;
             END;

             IF @V_PRIIMP  = 0 BEGIN
                DECLARE C_IMPOSTOCS CURSOR FOR
                   SELECT R.CDIMPOSTO, SUM(VRIMPOSTOIT) AS VALORIMPOSTO
                     FROM IMPOSTOROP R, ITEMPROIMPOS T, ITEMPRODUTO I
                    WHERE (I.CDFILIAL     = @V_CDFILIAL)
                      AND (I.NRLANCTONF   = @V_NRLANCTONF)
                      AND (I.CDFILIAL     = T.CDFILIAL)
                      AND (I.NRLANCTONF   = T.NRLANCTONF)
                      AND (I.NRSEQITPROD  = T.NRSEQITPROD)
                      AND (T.NRITPROIMPOS = '1')
                      AND (T.CDIMPOSTO    = R.CDIMPOSTO)
                      AND (R.CDFILIAL     = @V_FILIALPAR)
                      AND (R.IDTPIMPOSTOROP = 'CS')
                    GROUP BY R.CDIMPOSTO;

                OPEN C_IMPOSTOCS;
                FETCH NEXT FROM C_IMPOSTOCS INTO @V_CDPRODUTO, @V_VRIMPOSTO;

                WHILE (@@FETCH_STATUS = 0) BEGIN

                   SET @V_NRSEQRELACIT = @V_NRSEQRELACIT + 1;

                   INSERT INTO ITRELACITROP
                    (CDFILIAL,  NRROPFILIAL, NRLANCROP, NRITLANCROP, NRSEQRELACITROP,
                     CDITRELITROP, QTITRELITROP, VRITRELITROP)
                    VALUES
                    (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_NRSEQRELACIT,
                     @V_CDPRODUTO, 0, @V_VRIMPOSTO)


                   FETCH NEXT FROM C_IMPOSTOCS INTO @V_CDPRODUTO, @V_VRIMPOSTO;
                   SET @V_PRIIMP = 1;
                END;
                CLOSE C_IMPOSTOCS ;
                DEALLOCATE C_IMPOSTOCS;
             END;
             FETCH NEXT FROM C_ITCONSSAIDA INTO @V_CDSUBGRPROD, @V_CDGRUPPROD,
                                                @V_VALORTOTAL,  @V_QUANTIDADE;


          END;
          CLOSE C_ITCONSSAIDA ;
          DEALLOCATE C_ITCONSSAIDA;

          FETCH NEXT FROM C_CONSSAIDA INTO @V_CDCLIENTE,  @V_CDTIPOOPER, @V_NRNOTAFISC, @V_CDFILIAL,
                                           @V_NRLANCTONF, @V_DTENTRSAID, @V_CDSERIE, @V_CDFORNECED,
                                           @V_IDSTATUS,   @V_DTINIREFEFAT, @V_DTFINREFEFAT, @V_NUMERORE;

      END;
      CLOSE C_CONSSAIDA ;
      DEALLOCATE C_CONSSAIDA;
   END;

   IF (@V_IDIMPLANTROP = 'S' OR @V_IDAJUSTEROP = 'S') BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      SELECT
             @V_CDPRODFIN    = MAX(CDARVPROD),
             @V_CDPRODINI    = MIN(CDARVPROD)
      FROM ITLANCTOEST I, PRODUTO P
      WHERE CDFILIMOVI  =  @P_CDFILIAL                     AND
            DTLANCMOVI BETWEEN @V_DTINIC AND @P_DTFINAL AND
            I.CDPRODMOVI = P.CDPRODUTO                      AND
            IDTIPOMOVI IN ('0','1');


      EXEC TEKNISA.NOVO_CODIGO 'MOVIESTOQUE', @P_SEQUENCIAL = @V_NRMOVIESTQ OUTPUT, @P_QTDE = 1;

      SET @V_NRMOVIESTQ = SUBSTRING(@V_NRMOVIESTQ, 11, 10);

     EXEC TEKNISA.MOVIMENTACAO_ESTOQUE @P_CDFILIAL,'','','', 1, @V_DTINIC, @P_DTFINAL, @V_CDPRODINI, @V_CDPRODFIN, 3, 1, @V_NRMOVIESTQ;

      SET @V_PRODUTO = '';


      IF @V_IDIMPLANTROP = 'S' BEGIN
         SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
         SET @V_ULTLANCMOVIEST = 'U';
         DECLARE C_IMPLANTACAO CURSOR FOR
            SELECT AN.CDGRUPPROD, AN.CDSUBGRPROD, DTLANCMOVIEST,
                   SUM(QTLANCMOVIEST) QTLANCMOVIEST, SUM(VRDIFECUST) VRDIFECUST
              FROM RELAT_MOVIEST R, PRODUTO P, GRUPPROD GR,
                   SUBGRUPPROD SG, PARFILIALROP PR, PRSUBGRPROD AN
             WHERE (R.CDFILIMOVIEST = @P_CDFILIAL)
               AND (R.NRRELATMOVI   = @V_NRMOVIESTQ)
               AND (R.DTLANCMOVIEST BETWEEN @V_DTINIC AND @P_DTFINAL)
               AND (CDFILISUBGR     = @V_CDFILISUBGR)
               AND (PR.CDFILIAL     = @V_FILIALPAR)
               AND (PR.CDGRUPPROD   = GR.CDGRUPPROD)
               AND (GR.CDGRUPPROD   = SG.CDGRUPPROD)
               AND (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)
               AND (P.CDPRODUTO     = AN.CDPRODUTO)
               AND (SG.CDGRUPPROD   = AN.CDGRUPPROD)
               AND (R.IDTIPOMOVIEST = '0')
               AND (CDPRODMOVIEST   = P.CDARVPROD)
             GROUP BY DTLANCMOVIEST, AN.CDGRUPPROD, AN.CDSUBGRPROD
             ORDER BY DTLANCMOVIEST, AN.CDGRUPPROD, AN.CDSUBGRPROD;

         OPEN C_IMPLANTACAO;
         FETCH NEXT FROM C_IMPLANTACAO INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_DTLANCMOVIEST,
                                            @V_QTLANCMOVIEST, @V_VRDIFECUST;
         WHILE (@@FETCH_STATUS = 0)   BEGIN

            IF @V_DTLANCROP <> @V_DTLANCMOVIEST BEGIN
               SET @V_NRROPFILIAL = NULL;
               SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
               FROM ROPFILIAL
               WHERE CDFILIAL    = @P_CDFILIAL AND
                     DTFILIALROP = @V_DTLANCMOVIEST;

               SET @V_DTLANCROP  = @V_DTLANCMOVIEST;
               IF @V_NRROPFILIAL IS NULL BEGIN
                  SET @V_NRROPFILIAL = @V_NRROPFILINI;
               END;
            END;

                /*Inclui implantao */
            SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

            INSERT INTO LANCROPFILIAL
               (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,  NRLANCTONFROP,CDFILCENTROP)
            VALUES
               (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTLANCMOVIEST, 'IM', '',
                '',  '', '', '','', @V_CDFILCENTROP);

            SET @V_NRITLANCROP = '00001';

            INSERT INTO ITLANCROPFILIAL
               (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP,
                CDGRUPPRODROP, CDSUBGRPRODROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, '',
                '', '', @V_CDSUBGRPROD,  @V_QTLANCMOVIEST, @V_VRDIFECUST,
                @V_CDGRUPPROD, @V_CDSUBGRPROD );

            SET @V_CONSUMO = @V_CONSUMO + @V_VRDIFECUST;


            FETCH NEXT FROM C_IMPLANTACAO INTO @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_DTLANCMOVIEST,
                                            @V_QTLANCMOVIEST, @V_VRDIFECUST;
         END;
         CLOSE C_IMPLANTACAO;
         DEALLOCATE C_IMPLANTACAO;
      END;

      IF @V_IDAJUSTEROP = 'S' BEGIN
         SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
         DECLARE C_AJUSTE CURSOR FOR
            SELECT AN.CDGRUPPROD, AN.CDSUBGRPROD, DTLANCMOVIEST,
                   SUM(QTLANCMOVIEST) QTLANCMOVIEST, SUM(VRDIFECUST) VRDIFECUST
              FROM RELAT_MOVIEST R, PRODUTO P, GRUPPROD GR,
                   SUBGRUPPROD SG, PARFILIALROP PR, PRSUBGRPROD AN
             WHERE (R.CDFILIMOVIEST = @P_CDFILIAL)
               AND (R.NRRELATMOVI   = @V_NRMOVIESTQ)
               AND (R.DTLANCMOVIEST BETWEEN @V_DTINIC AND @P_DTFINAL)
               AND (CDFILISUBGR     = @V_CDFILISUBGR)
               AND (PR.CDFILIAL     = @V_FILIALPAR)
               AND (PR.CDGRUPPROD   = GR.CDGRUPPROD)
               AND (GR.CDGRUPPROD   = SG.CDGRUPPROD)
               AND (SG.CDSUBGRPROD  = AN.CDSUBGRPROD)
               AND (P.CDPRODUTO     = AN.CDPRODUTO)
               AND (SG.CDGRUPPROD   = AN.CDGRUPPROD)
               AND (R.IDTIPOMOVIEST = '1')
               AND (CDPRODMOVIEST   = P.CDARVPROD)
             GROUP BY DTLANCMOVIEST, AN.CDGRUPPROD, AN.CDSUBGRPROD
             ORDER BY DTLANCMOVIEST, AN.CDGRUPPROD, AN.CDSUBGRPROD;

         OPEN C_AJUSTE;
         FETCH NEXT FROM C_AJUSTE INTO @V_CDGRUPPROD, @V_CDSUBGRPROD,  @V_DTLANCMOVIEST,
                                       @V_QTLANCMOVIEST, @V_VRDIFECUST;

         WHILE (@@FETCH_STATUS = 0)   BEGIN
            IF @V_DTLANCROP <> @V_DTLANCMOVIEST BEGIN
               SET @V_NRROPFILIAL = NULL;
               SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
               FROM ROPFILIAL
               WHERE CDFILIAL    = @P_CDFILIAL AND
                     DTFILIALROP = @V_DTLANCMOVIEST;

               SET @V_DTLANCROP   = @V_DTLANCMOVIEST;
               IF @V_NRROPFILIAL IS NULL BEGIN
                  SET @V_NRROPFILIAL = @V_NRROPFILINI;
               END;
            END;

            SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);

            INSERT INTO LANCROPFILIAL
               (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
            VALUES
               (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTLANCMOVIEST, 'AJ', '',
                '',  '', '', '', '', @V_CDFILCENTROP);

                /*Inclui Item do Lanamento
            SET @V_NRITLANCROP = RIGHT('00000'+@V_NRITLANCROP + 1,5); */

            SET @V_NRITLANCROP = '00001';

            INSERT INTO ITLANCROPFILIAL
               (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, '',
                '', '', @V_CDSUBGRPROD,  @V_QTLANCMOVIEST, @V_VRDIFECUST);


            FETCH NEXT FROM C_AJUSTE INTO @V_CDGRUPPROD, @V_CDSUBGRPROD,  @V_DTLANCMOVIEST,
                                          @V_QTLANCMOVIEST, @V_VRDIFECUST;
         END;
         CLOSE C_AJUSTE;
         DEALLOCATE C_AJUSTE;
      END;
   END;

   /*Clculo da Retirada*/

      /*Retirada de Estoque*/
   IF @V_IDRETIRADAROP = 'E' OR @V_IDRETIRADAROP = 'A'  BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      DECLARE C_RETIRADA CURSOR FOR
         SELECT L.CDFILIAL, L.NRLANCESTQ, L.DTLANCESTQ
         FROM LANCTOESTOQ L, RETIRADAESTO R
         WHERE (L.CDFILIMOVI = @P_CDFILIAL  )
           AND (L.DTLANCESTQ BETWEEN @V_DTINIC AND @P_DTFINAL)
           AND (L.IDTPLANCTO = '3'          )
           AND (L.CDFILIAL   = R.CDFILIALLAN)
           AND (L.NRLANCESTQ = R.NRLANCESTQ )
         ORDER BY L.NRLANCESTQ,   L.DTLANCESTQ;
      OPEN C_RETIRADA ;
      FETCH NEXT FROM C_RETIRADA  INTO @V_CDFILIAL, @V_NRLANCESTQ, @V_DTLANCESTQ;

      WHILE (@@FETCH_STATUS = 0)   BEGIN
         IF @V_DTLANCROP <> @V_DTLANCESTQ BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
            FROM ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  DTFILIALROP = @V_DTLANCESTQ;

            SET @V_DTLANCROP   = @V_DTLANCESTQ;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
          /*Inclui Retirada de Estoque */
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP )
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTLANCESTQ, 'RE', '',
             '',  '', '', @V_CDFILIAL, @V_NRLANCESTQ, @V_CDFILCENTROP);

         DECLARE C_ITRETIRADA CURSOR FOR
            SELECT CDPRODMOVI, IT.QTLANCTOEST, SG.CDGRUPPROD, AN.CDSUBGRPROD,
               (TEKNISA.CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, @V_NRTIPOCUSTO, @V_DTLANCESTQ, GETDATE(),
                                            CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) * IT.QTLANCTOEST) AS VRLANCTOESTQ
            FROM ITLANCTOEST IT, GRUPPROD GR,  SUBGRUPPROD SG, PRSUBGRPROD AN
            WHERE (IT.CDFILIAL   = @V_CDFILIAL  )
              AND (IT.NRLANCESTQ = @V_NRLANCESTQ)
              AND (ISNULL(IT.IDEVOLESTOQ, 'S') = 'S')
              AND (CDFILISUBGR    = @V_CDFILISUBGR)
              AND (GR.CDGRUPPROD  = @V_CDGRUPPROD)
              AND (GR.CDGRUPPROD  = SG.CDGRUPPROD)
              AND (SG.CDSUBGRPROD = AN.CDSUBGRPROD)
              AND (IT.CDPRODMOVI  = AN.CDPRODUTO)
              AND (SG.CDGRUPPROD  = AN.CDGRUPPROD);


         OPEN C_ITRETIRADA ;
         FETCH NEXT FROM C_ITRETIRADA  INTO @V_CDPRODMOVI, @V_QTLANCTOEST, @V_CDGRUPPRODRET, @V_CDSUBGRPROD, @V_VRLANCTOESTQ;

         WHILE (@@FETCH_STATUS = 0)   BEGIN

            /*Inclui Item d Retirada*/
            SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

            INSERT INTO ITLANCROPFILIAL
               (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP, CDGRUPPRODROP, CDSUBGRPRODROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, @V_NRLANCESTQ,
                '', @V_CDPRODMOVI,  @V_QTLANCTOEST, @V_VRLANCTOESTQ, @V_CDGRUPPRODRET, @V_CDSUBGRPROD);

            FETCH NEXT FROM C_ITRETIRADA  INTO @V_CDPRODMOVI, @V_QTLANCTOEST, @V_CDGRUPPRODRET, @V_CDSUBGRPROD, @V_VRLANCTOESTQ;
            
         END;
         CLOSE C_ITRETIRADA;
         DEALLOCATE C_ITRETIRADA;

         FETCH NEXT FROM C_RETIRADA  INTO @V_CDFILIAL, @V_NRLANCESTQ, @V_DTLANCESTQ;
      END;
      CLOSE C_RETIRADA;
      DEALLOCATE C_RETIRADA;
   END;


   /*Retirada por Planejamento*/
   IF (@V_IDRETIRADAROP = 'P' OR @V_IDRETIRADAROP = 'A') AND (@V_IDSERVRETROP <> 'S') BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      DECLARE C_RETIRADAPLA CURSOR FOR
         SELECT DISTINCT
            PRO.CDSERVFILI, PRO.DTCARDAPIO, PRO.CDFILIALLANC, PRO.NRLANCESTQ
         FROM
            (SELECT
               PROD.CDFILIAL, PROD.CDSERVFILI, PROD.DTCARDAPIO,
               PROD.CDFILIALLANC, PROD.NRLANCESTQ
             FROM(
               SELECT
                  CDFILIAL, CDSERVFILI, DTCARDAPIO , CDFILIALLANC, NRLANCESTQ
               FROM
                  (SELECT
                     CDFILIAL, CDSERVFILI, DTCARDAPIO, CDFILIALLANC, NRLANCESTQ
                   FROM
                     (SELECT
                        CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO,
                        IL.CDFILIAL AS CDFILIALLANC, IL.NRLANCESTQ
                     FROM
                        CARDADIA CA, ITEMRETI IR, ITLANCTOEST IL, PRODUTO  PRA,
                        FILIAL   FI, SERVICO  SE, PRODUTO  PRB, SERVICOROP P
                     WHERE
                        (CA.CDFILIAL   = @P_CDFILIAL )                       AND
                        (@V_FILIALPAR   = P.CDFILIAL )                       AND
                        (CA.CDSERVFILI =  P.CDSERVFILI)                     AND
                        (NOT IR.QTRETIRADA IS NULL AND IR.QTRETIRADA <> 0)  AND
                        (IL.CDFILIAL    = IR.CDFIITLANEST)                  AND
                        (IL.NRLANCESTQ  = IR.NRLANCESTQ)                    AND
                        (IL.NRSEQUITEM  = IR.NRSEQUITEM)                    AND
                        (IL.IDEVOLESTOQ = 'S')                              AND
                        (CA.DTCARDAPIO BETWEEN @V_DTINIC AND @P_DTFINAL)   AND
                        (CA.CDFILIAL   = IR.CDFILIAL)                       AND
                        (CA.NRCARDAPIO = IR.NRCARDAPIO)                     AND
                        (PRA.CDPRODUTO = IR.CDPRODUTO)                      AND
                        (PRB.CDPRODUTO = PRA.CDPRODESTO)                    AND
                        (FI.CDFILIAL   = CA.CDFILIAL)                       AND
                        (SE.CDFILIAL   = CA.CDFILIAL)                       AND
                        (SE.CDSERVFILI = CA.CDSERVFILI))W)X) PROD) PRO LEFT JOIN
                            (SELECT C.CDFILIAL, C.CDSERVFILI, DTCARDAPIO
                             FROM CARDADIA C, SERVICOROP P
                             WHERE (C.CDFILIAL   = @P_CDFILIAL)                 AND
                                   (@V_FILIALPAR = P.CDFILIAL)                 AND
                                   (C.CDSERVFILI = P.CDSERVFILI)               AND
                                   (DTCARDAPIO BETWEEN @V_DTINIC AND @P_DTFINAL)
                             GROUP BY C.CDFILIAL, C.CDSERVFILI, DTCARDAPIO) COMENS ON
                                 (COMENS.CDFILIAL   = PRO.CDFILIAL) AND
                                 (COMENS.CDSERVFILI = PRO.CDSERVFILI) AND
                                 (COMENS.DTCARDAPIO = PRO.DTCARDAPIO);
      OPEN C_RETIRADAPLA ;

      FETCH NEXT FROM C_RETIRADAPLA  INTO @V_CDSERVFILI, @V_DTCARDAPIO, @V_CDFILIALLANC, @V_NRLANCESTQ;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTCARDAPIO BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
            FROM ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  DTFILIALROP = @V_DTCARDAPIO;

            SET @V_DTLANCROP   = @V_DTCARDAPIO;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;

          /*Inclui Retirada de Planejamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTCARDAPIO, 'RP', '',
             '',  '', '', @V_CDFILIALLANC, @V_NRLANCESTQ, @V_CDFILCENTROP);

          DECLARE C_ITRETIRADAPLA CURSOR FOR
             SELECT
                   PROD.CDFILIAL, PROD.CDSERVFILI, PROD.DTCARDAPIO, SG.CDGRUPPROD, AN.CDSUBGRPROD,
                   SUM(PROD.VRCUSTPROD) AS VRCUSTPROD, SUM(QTRETIRADA) QTRETIRADA
               FROM GRUPPROD GR,  SUBGRUPPROD SG, PRSUBGRPROD AN,
                    (SELECT
                        CDFILIAL,(CASE @V_IDRETIRADAROP WHEN 'A' THEN CDPRODUTO ELSE CDPRODUTO END) CDSERVFILI,
                        DTCARDAPIO, QTCOMEFETCAR, QTCLIEFETCAR, QTRETIRADA,
                        SUM(VRCUSTPROD) AS VRCUSTPROD
                     FROM
                        (SELECT
                           CDFILIAL, CDSERVFILI, DTCARDAPIO, QTCOMEFETCAR, QTCLIEFETCAR, CDPRODUTO, QTRETIRADA,
                           TEKNISA.CUSTO_PRODUTO(CDFILIAL, CDPRODUTO, @V_NRTIPOCUSTO, DTCARDAPIO, GETDATE()) * QTRETIRADA AS VRCUSTPROD
                         FROM
                           (SELECT
                              CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO,
                              CA.QTCOMEFETCAR, CA.QTCLIEFETCAR, PRB.CDPRODUTO,
                              SUM(IR.QTRETIRADA * PRA.VRFATOCONV) AS QTRETIRADA
                           FROM
                             CARDADIA CA, ITLANCTOEST IL, PRODUTO  PRA,
                             PRODUTO  PRB, SERVICOROP P, ITEMRETI IR
                           WHERE
                              (CA.CDFILIAL    = @P_CDFILIAL )                      AND
                              (@V_FILIALPAR   = P.CDFILIAL )                      AND
                              (CA.CDSERVFILI  =  P.CDSERVFILI)                    AND
                              (IDTPSERVICOROP = 'R')                              AND
                              (IL.CDFILIAL    = @V_CDFILIALLANC)       AND
                              (IL.NRLANCESTQ  = @V_NRLANCESTQ)         AND
                              (IL.CDFILIAL    = IR.CDFIITLANEST)                  AND
                              (IL.NRLANCESTQ  = IR.NRLANCESTQ)                    AND
                              (IL.NRSEQUITEM  = IR.NRSEQUITEM)                    AND
                              (IL.IDEVOLESTOQ = 'S')                              AND
                              (CA.CDFILIAL   = IR.CDFILIAL)                       AND
                              (CA.NRCARDAPIO = IR.NRCARDAPIO)                     AND
                              (PRA.CDPRODUTO = IR.CDPRODUTO)                      AND
                              (PRB.CDPRODUTO = PRA.CDPRODESTO)

                           GROUP BY
                              CA.CDFILIAL,CA.CDSERVFILI,CA.DTCARDAPIO,CA.QTCOMEFETCAR,
                              CA.QTCLIEFETCAR, PRB.CDPRODUTO)A)B
                     GROUP BY
                        CDFILIAL, CDSERVFILI, DTCARDAPIO, QTCOMEFETCAR, QTCLIEFETCAR,
                        CDPRODUTO, QTRETIRADA) PROD
              WHERE (CDFILISUBGR    = @V_CDFILISUBGR)
                AND (GR.CDGRUPPROD  = @V_CDGRUPPROD)
                AND (GR.CDGRUPPROD  = SG.CDGRUPPROD)
                AND (SG.CDSUBGRPROD = AN.CDSUBGRPROD)
                AND (PROD.CDSERVFILI    = AN.CDPRODUTO)
                AND (SG.CDGRUPPROD  = AN.CDGRUPPROD)
              GROUP BY PROD.CDFILIAL, PROD.CDSERVFILI, PROD.DTCARDAPIO, SG.CDGRUPPROD, AN.CDSUBGRPROD;

         OPEN C_ITRETIRADAPLA ;
         FETCH NEXT FROM C_ITRETIRADAPLA  INTO @V_CDFILIAL, @V_CDSERVFILI, @V_DTCARDAPIO,
                                               @V_CDGRUPPRODRET, @V_CDSUBGRPROD,
                                               @V_VRCUSTPROD, @V_QTRETIRADA;
         WHILE (@@FETCH_STATUS = 0)   BEGIN

             /*Inclui Item d Retirada*/
             SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

             INSERT INTO ITLANCROPFILIAL
                (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                 NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP, CDGRUPPRODROP, CDSUBGRPRODROP)
             VALUES
                (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIALLANC, @V_NRLANCESTQ,
                 '', @V_CDSERVFILI,  @V_QTRETIRADA, @V_VRCUSTPROD, @V_CDGRUPPRODRET, @V_CDSUBGRPROD);

             FETCH NEXT FROM C_ITRETIRADAPLA  INTO @V_CDFILIAL, @V_CDSERVFILI, @V_DTCARDAPIO,
                                                   @V_CDGRUPPRODRET, @V_CDSUBGRPROD,
                                                   @V_VRCUSTPROD, @V_QTRETIRADA;

         END;
         CLOSE C_ITRETIRADAPLA;
         DEALLOCATE C_ITRETIRADAPLA;

         FETCH NEXT FROM C_RETIRADAPLA  INTO @V_CDSERVFILI, @V_DTCARDAPIO, @V_CDFILIALLANC, @V_NRLANCESTQ;

      END;
      CLOSE C_RETIRADAPLA;
      DEALLOCATE C_RETIRADAPLA;
   END;

   IF (@V_IDRETIRADAROP = 'P' OR @V_IDRETIRADAROP = 'A') AND (@V_IDSERVRETROP = 'S') BEGIN
      SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
      DECLARE C_RETIRADAPLA CURSOR FOR
         SELECT DISTINCT
            PRO.CDSERVFILI, PRO.DTCARDAPIO, PRO.CDFILIALLANC, PRO.NRLANCESTQ
         FROM
            (SELECT
               PROD.CDFILIAL, PROD.CDSERVFILI, PROD.DTCARDAPIO,
               PROD.CDFILIALLANC, PROD.NRLANCESTQ
             FROM(
               SELECT
                  CDFILIAL, CDSERVFILI, DTCARDAPIO , CDFILIALLANC, NRLANCESTQ
               FROM
                  (SELECT
                     CDFILIAL, CDSERVFILI, DTCARDAPIO, CDFILIALLANC, NRLANCESTQ
                   FROM
                     (SELECT
                        CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO,
                        IL.CDFILIAL AS CDFILIALLANC, IL.NRLANCESTQ
                     FROM
                        CARDADIA CA, ITEMRETI IR, ITLANCTOEST IL, PRODUTO  PRA,
                        FILIAL   FI, SERVICO  SE, PRODUTO  PRB
                     WHERE
                        (CA.CDFILIAL   = @P_CDFILIAL )                       AND
                        (NOT IR.QTRETIRADA IS NULL AND IR.QTRETIRADA <> 0)  AND
                        (IL.CDFILIAL    = IR.CDFIITLANEST)                  AND
                        (IL.NRLANCESTQ  = IR.NRLANCESTQ)                    AND
                        (IL.NRSEQUITEM  = IR.NRSEQUITEM)                    AND
                        (IL.IDEVOLESTOQ = 'S')                              AND
                        (CA.DTCARDAPIO BETWEEN @V_DTINIC AND @P_DTFINAL)   AND
                        (CA.CDFILIAL   = IR.CDFILIAL)                       AND
                        (CA.NRCARDAPIO = IR.NRCARDAPIO)                     AND
                        (PRA.CDPRODUTO = IR.CDPRODUTO)                      AND
                        (PRB.CDPRODUTO = PRA.CDPRODESTO)                    AND
                        (FI.CDFILIAL   = CA.CDFILIAL)                       AND
                        (SE.CDFILIAL   = CA.CDFILIAL)                       AND
                        (SE.CDSERVFILI = CA.CDSERVFILI))W)X) PROD) PRO LEFT JOIN
                            (SELECT C.CDFILIAL, C.CDSERVFILI, DTCARDAPIO
                             FROM CARDADIA C
                             WHERE (C.CDFILIAL   = @P_CDFILIAL)                 AND
                                   (DTCARDAPIO BETWEEN @V_DTINIC AND @P_DTFINAL)
                             GROUP BY C.CDFILIAL, C.CDSERVFILI, DTCARDAPIO) COMENS ON
                                 (COMENS.CDFILIAL   = PRO.CDFILIAL) AND
                                 (COMENS.CDSERVFILI = PRO.CDSERVFILI) AND
                                 (COMENS.DTCARDAPIO = PRO.DTCARDAPIO);
      OPEN C_RETIRADAPLA ;
      FETCH NEXT FROM C_RETIRADAPLA  INTO @V_CDSERVFILI, @V_DTCARDAPIO, @V_CDFILIALLANC, @V_NRLANCESTQ;

      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
         IF @V_DTLANCROP <> @V_DTCARDAPIO BEGIN
            SET @V_NRROPFILIAL = NULL;
            SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
            FROM ROPFILIAL
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  DTFILIALROP = @V_DTCARDAPIO;

            SET @V_DTLANCROP   = @V_DTCARDAPIO;
            IF @V_NRROPFILIAL IS NULL BEGIN
               SET @V_NRROPFILIAL = @V_NRROPFILINI;
            END;
         END;

          /*Inclui Retirada de Planejamento*/
         INSERT INTO LANCROPFILIAL
            (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
             NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
         VALUES
            (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTCARDAPIO, 'RP', '',
             '',  '', '', @V_CDFILIALLANC, @V_NRLANCESTQ, @V_CDFILCENTROP);

          DECLARE C_ITRETIRADAPLA CURSOR FOR
            SELECT
               PROD.CDFILIAL, PROD.CDSERVFILI, PROD.DTCARDAPIO, SG.CDGRUPPROD, AN.CDSUBGRPROD,
               SUM(PROD.VRCUSTPROD) AS VRCUSTPROD, SUM(QTRETIRADA) QTRETIRADA
            FROM GRUPPROD GR,  SUBGRUPPROD SG, PRSUBGRPROD AN,
            (
               SELECT
                  CDFILIAL,     (CASE @V_IDRETIRADAROP WHEN 'A' THEN CDPRODUTO ELSE CDPRODUTO END) CDSERVFILI, DTCARDAPIO, QTCOMEFETCAR,
                  QTCLIEFETCAR, QTRETIRADA,
                  SUM(VRCUSTPROD) AS VRCUSTPROD
               FROM
                  (SELECT
                     CDFILIAL, CDSERVFILI, DTCARDAPIO, QTCOMEFETCAR, QTCLIEFETCAR, CDPRODUTO, QTRETIRADA,
                     TEKNISA.CUSTO_PRODUTO(CDFILIAL, CDPRODUTO, @V_NRTIPOCUSTO, DTCARDAPIO, GETDATE()) * QTRETIRADA AS VRCUSTPROD
                   FROM
                     (SELECT
                        CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO,
                        CA.QTCOMEFETCAR, CA.QTCLIEFETCAR, PRB.CDPRODUTO,
                        SUM(IR.QTRETIRADA * PRA.VRFATOCONV) AS QTRETIRADA
                     FROM
                       CARDADIA CA, ITLANCTOEST IL, PRODUTO  PRA,
                       PRODUTO  PRB, ITEMRETI IR
                     WHERE
                        (CA.CDFILIAL    = @P_CDFILIAL )                      AND
                        (IL.CDFILIAL    = @V_CDFILIALLANC)       AND
                        (IL.NRLANCESTQ  = @V_NRLANCESTQ)         AND
                        (IL.CDFILIAL    = IR.CDFIITLANEST)                  AND
                        (IL.NRLANCESTQ  = IR.NRLANCESTQ)                    AND
                        (IL.NRSEQUITEM  = IR.NRSEQUITEM)                    AND
                        (IL.IDEVOLESTOQ = 'S')                              AND
                        (CA.CDFILIAL   = IR.CDFILIAL)                       AND
                        (CA.NRCARDAPIO = IR.NRCARDAPIO)                     AND
                        (PRA.CDPRODUTO = IR.CDPRODUTO)                      AND
                        (PRB.CDPRODUTO = PRA.CDPRODESTO)
                     GROUP BY
                        CA.CDFILIAL,CA.CDSERVFILI,CA.DTCARDAPIO,CA.QTCOMEFETCAR,
                        CA.QTCLIEFETCAR, PRB.CDPRODUTO)A)B
               GROUP BY
                  CDFILIAL, CDSERVFILI, DTCARDAPIO, QTCOMEFETCAR, QTCLIEFETCAR,
                  CDPRODUTO, QTRETIRADA) PROD
              WHERE (CDFILISUBGR    = @V_CDFILISUBGR)
                AND (GR.CDGRUPPROD  = @V_CDGRUPPROD)
                AND (GR.CDGRUPPROD  = SG.CDGRUPPROD)
                AND (SG.CDSUBGRPROD = AN.CDSUBGRPROD)
                AND (PROD.CDSERVFILI = AN.CDPRODUTO)
                AND (SG.CDGRUPPROD  = AN.CDGRUPPROD)

               GROUP BY PROD.CDFILIAL, PROD.CDSERVFILI, PROD.DTCARDAPIO, SG.CDGRUPPROD, AN.CDSUBGRPROD;

         OPEN C_ITRETIRADAPLA ;
         FETCH NEXT FROM C_ITRETIRADAPLA  INTO @V_CDFILIAL, @V_CDSERVFILI, @V_DTCARDAPIO,
                                               @V_CDGRUPPRODRET, @V_CDSUBGRPROD,
                                               @V_VRCUSTPROD, @V_QTRETIRADA;
         WHILE (@@FETCH_STATUS = 0)   BEGIN

             /*Inclui Item d Retirada*/
             SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

             INSERT INTO ITLANCROPFILIAL
                (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                 NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP, CDGRUPPRODROP, CDSUBGRPRODROP)
             VALUES
                (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIALLANC, @V_NRLANCESTQ,
                 '', @V_CDSERVFILI,  @V_QTRETIRADA, @V_VRCUSTPROD, @V_CDGRUPPRODRET, @V_CDSUBGRPROD);

             FETCH NEXT FROM C_ITRETIRADAPLA  INTO @V_CDFILIAL, @V_CDSERVFILI, @V_DTCARDAPIO,
                                               @V_CDGRUPPRODRET, @V_CDSUBGRPROD,
                                               @V_VRCUSTPROD, @V_QTRETIRADA;
          END;
          FETCH NEXT FROM C_RETIRADAPLA  INTO @V_CDSERVFILI, @V_DTCARDAPIO, @V_CDFILIALLANC, @V_NRLANCESTQ;
          CLOSE C_ITRETIRADAPLA;
          DEALLOCATE C_ITRETIRADAPLA;
      END;
      CLOSE C_RETIRADAPLA;
      DEALLOCATE C_RETIRADAPLA;
   END;

   /*Calculo das Depesas*/

   IF @V_IDTPAPURACAO = '2' BEGIN

      /*Lanamentos de Despesas Diversas*/
      IF @V_IDDESPDIVROP = 'S' BEGIN
         SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
         SET @V_NRITLANCROP = '00000';
         DECLARE C_DESPESASDIV CURSOR FOR
            SELECT
               D.CDFILIAL, D.CDDESPPREV, D.DTPRDESPFILI,
               D.VRPRDESPFILI, D.VRREDESPFILI, IDDESTACAROP
            FROM
               DESPPREVFILI D,  DESPPREV E
            WHERE
               (D.CDFILIAL = @P_CDFILIAL)              AND
               (D.CDDESPPREV   = E.CDDESPPREV)              AND
               (D.DTPRDESPFILI BETWEEN @V_DTINIC AND @P_DTFINAL);

         OPEN C_DESPESASDIV;
         FETCH NEXT FROM C_DESPESASDIV  INTO @V_CDFILIAL, @V_CDDESPPREV, @V_DTPRDESPFILI,
                                             @V_VRPRDESPFILI, @V_VRREDESPFILI, @V_IDDESTACAROP;
         WHILE (@@FETCH_STATUS = 0)   BEGIN

            SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
            IF @V_DTLANCROP <> @V_DTPRDESPFILI BEGIN
               SET @V_NRROPFILIAL = NULL;
               SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
               FROM ROPFILIAL
               WHERE CDFILIAL    = @P_CDFILIAL AND
                     DTFILIALROP = @V_DTPRDESPFILI;

               SET @V_DTLANCROP   = @V_DTPRDESPFILI;
               IF @V_NRROPFILIAL IS NULL BEGIN
                  SET @V_NRROPFILIAL = @V_NRROPFILINI;
               END;
            END;

           /* Inclui Despesas Diversas*/

            IF @V_IDDESTACAROP = 'S' BEGIN
               SET @V_CONSUMO = @V_CONSUMO + @V_VRREDESPFILI;
            END;

            INSERT INTO LANCROPFILIAL
               (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
            VALUES
               (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTPRDESPFILI, CASE @V_IDDESTACAROP WHEN 'S' THEN 'CD' ELSE 'DD' END, '',
                '',  '', '', @V_CDFILIAL, '', @V_CDFILCENTROP);

            SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

            INSERT INTO ITLANCROPFILIAL
               (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, '',
                '',  @V_CDDESPPREV,  1, @V_VRREDESPFILI);

            FETCH NEXT FROM C_DESPESASDIV  INTO @V_CDFILIAL, @V_CDDESPPREV, @V_DTPRDESPFILI,
                                             @V_VRPRDESPFILI, @V_VRREDESPFILI, @V_IDDESTACAROP;
         END;
         CLOSE C_DESPESASDIV;
         DEALLOCATE C_DESPESASDIV;
      END;


      IF @V_IDDESPMOBROP= 'S' BEGIN
      /*Lanamentos de Despesas com Mo-de-Obra  */

         SET @V_NRITLANCROP = '00000';
         SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
         DECLARE  C_DESPESASMO CURSOR FOR
            SELECT L.CDFILIAL, L.DTLANCDESFAT, L.CDDESPADMFAT,
                   L.VRLANCDESFAT, L.VRTXLANCDESP, L.VRPREVDESFAT
            FROM LANCDESPFATU L
            WHERE (L.CDFILIAL = @P_CDFILIAL)                           AND
                  (L.DTLANCDESFAT BETWEEN @V_DTINIC AND @P_DTFINAL);
         OPEN C_DESPESASMO;
         FETCH NEXT FROM C_DESPESASMO  INTO @V_CDFILIAL, @V_DTLANCDESFAT, @V_CDDESPADMFAT,
                                            @V_VRLANCDESFAT, @V_VRTXLANCDESP, @V_VRPREVDESFAT;
         WHILE (@@FETCH_STATUS = 0)   BEGIN
            SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
            IF @V_DTLANCROP <> @V_DTLANCDESFAT BEGIN
               SET @V_NRROPFILIAL = NULL;
               SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
               FROM ROPFILIAL
               WHERE CDFILIAL    = @P_CDFILIAL AND
                     DTFILIALROP = @V_DTLANCDESFAT;

               SET @V_DTLANCROP   = @V_DTLANCDESFAT;
               IF @V_NRROPFILIAL IS NULL BEGIN
                  SET @V_NRROPFILIAL = @V_NRROPFILINI;
               END;
            END;

            /*Inclui Despesas Mo de Obra*/

            INSERT INTO LANCROPFILIAL
               (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
            VALUES
               (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTLANCDESFAT, 'DM', '',
                '',  '', '', @V_CDFILIAL, '', @V_CDFILCENTROP);


            SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

            INSERT INTO ITLANCROPFILIAL
               (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, '',
                '', @V_CDDESPADMFAT,  1, @V_VRLANCDESFAT);
            FETCH NEXT FROM C_DESPESASMO  INTO @V_CDFILIAL, @V_DTLANCDESFAT, @V_CDDESPADMFAT,
                                            @V_VRLANCDESFAT, @V_VRTXLANCDESP, @V_VRPREVDESFAT;
         END;
         CLOSE C_DESPESASMO;
         DEALLOCATE C_DESPESASMO;
      END;

      IF @V_IDDESPENTROP = 'S' BEGIN
         SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
         DECLARE C_DESPCOMPRA CURSOR FOR
               SELECT N.CDCLIENTE,  N.CDTIPOOPER, N.NRNOTAFISC, N.CDFILIAL,
                      N.NRLANCTONF, DTENTRSAID,   N.CDSERIE, N.CDFORNECED
               FROM NOTAFISCAL N,  TIPOOPERACROP A
               WHERE
                  (N.CDFILIRECE   = @P_CDFILIAL)                           AND
                  (N.IDENTRSAIDOP = 'E')                                  AND
                  (@V_FILIALPAR   = A.CDFILIAL)                           AND
                  (N.CDTIPOOPER   = A.CDTIPOOPER)                         AND
                  (N.IDENTRSAIDOP = A.IDENTRSAIDOP)                       AND
                  (A.IDTPOPERACROP = 'DE')                                AND
                  (N.IDSTATUS    <> 'C')                                  AND
                  (N.IDSISTEMA NOT IN ('PAG','REC','FIS','CMP') OR N.IDSISTEMA IS NULL)  AND
                  (N.DTENTRSAID BETWEEN @P_DTINICIAL AND @P_DTFINAL);

            OPEN C_DESPCOMPRA;
            FETCH NEXT FROM C_DESPCOMPRA INTO @V_CDCLIENTE, @V_CDTIPOOPER, @V_NRNOTAFISC, @V_CDFILIAL,
                                              @V_NRLANCTONF, @V_DTENTRSAID,   @V_CDSERIE, @V_CDFORNECED;
         WHILE (@@FETCH_STATUS = 0)   BEGIN

            SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
            IF @V_DTLANCROP <> @V_DTENTRSAID BEGIN
               SET @V_NRROPFILIAL = NULL;
               SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
               FROM ROPFILIAL
               WHERE CDFILIAL    = @P_CDFILIAL AND
                     DTFILIALROP = @V_DTENTRSAID;

               SET @V_DTLANCROP   =@V_DTENTRSAID;
               IF @V_NRROPFILIAL IS NULL BEGIN
                  SET @V_NRROPFILIAL = @V_NRROPFILINI;
               END;
            END;

            /*Inclui Lanamento*/

            INSERT INTO LANCROPFILIAL
              (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
               NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP, IDSTATUSROP,
               DTINIREFEROP,  DTFINREFEROP)
            VALUES
              (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP,  @V_DTENTRSAID, 'DE', @V_CDFORNECED,
               @V_CDTIPOOPER,  @V_NRNOTAFISC, @V_CDSERIE, @V_CDFILIAL,
               @V_NRLANCTONF, @V_CDFILCENTROP, @V_IDSTATUS, @V_DTINIREFEFAT, @V_DTFINREFEFAT);

            SET @V_NRITLANCROP = '00000';

            DECLARE C_ITDESPCOMPRA CURSOR FOR
               SELECT DISTINCT I.CDPRODUTO, I.NRSEQITPROD,  I.VRBRUTITEM AS VALORTOTAL,
                     I.QTITEMPROD AS QUANTIDADE
                FROM ITEMPRODUTO I, PRODUTO P,
                     (SELECT DISTINCT A.CDPRODUTO
                        FROM PRODUTOROP R, PRODUTO A, PRODUTO B
                       WHERE (CHARINDEX(B.CDARVPROD, A.CDARVPROD) = 1)
                         AND R.CDPRODUTO = B.CDPRODUTO
                         AND R.CDFILIAL  = @V_FILIALPAR
                         AND IDTPPRODUTOROP = 'DE' ) A
               WHERE I.CDFILIAL     = @V_CDFILIAL
                 AND I.NRLANCTONF   = @V_NRLANCTONF
                 AND P.CDPRODUTO = I.CDPRODUTO
                 AND I.CDPRODUTO = A.CDPRODUTO;

            OPEN C_ITDESPCOMPRA;
            FETCH NEXT FROM C_ITDESPCOMPRA INTO @V_CDPRODUTO, @V_NRSEQITPROD, @V_VRBRUTITEM, @V_QUANTIDADE;
            WHILE (@@FETCH_STATUS = 0)   BEGIN

             /* Inclui Item do Lanamento */

               SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

               INSERT INTO ITLANCROPFILIAL
                  (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                   NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
               VALUES
                  (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, @V_NRLANCTONF,
                   @V_NRSEQITPROD, @V_CDPRODUTO,  @V_QUANTIDADE, @V_VRBRUTITEM);

                FETCH NEXT FROM C_ITDESPCOMPRA INTO @V_CDPRODUTO, @V_NRSEQITPROD, @V_VRBRUTITEM, @V_QUANTIDADE;
             END;
             CLOSE C_ITDESPCOMPRA;
             DEALLOCATE C_ITDESPCOMPRA;
             FETCH NEXT FROM C_DESPCOMPRA INTO @V_CDCLIENTE, @V_CDTIPOOPER, @V_NRNOTAFISC, @V_CDFILIAL,
                                               @V_NRLANCTONF, @V_DTENTRSAID,   @V_CDSERIE, @V_CDFORNECED;
         END;
         CLOSE C_DESPCOMPRA;
         DEALLOCATE C_DESPCOMPRA;
      END;


      /* Despesas Lanadas no Contas a Pagar */
      IF @V_IDAPUCTPGROP = 'S' BEGIN

         SET @V_DTLANCROP = '01/01/1990';
         SET @V_NRITLANCROP = '00000';

         DECLARE C_CONTAPAGAR CURSOR FOR  SELECT CP.CDFILIBPAG, CP.CDFILIAL, CP.NRLANCTONF, CP.NRSEQVENPAG, CP.NRPARCELAPAG, TC.CDTPCTPAGAR,
                                                 DTBAIXAPAG, ROUND(CP.VRATUAPAG, 2) + ((BO.VRFINALBPAG - BO.VRBOLPAG) * (CP.VRATUAPAG/BO.VRBOLPAG)) AS VRCONTARATEADA
                                            FROM CONTAPAGAR CP, BOLETPAGAR BO, BAIXAPAGA BP, TIPOCTPAGROP TC
                                           WHERE CP.CDFILIBPAG = BO.CDFILIAL
                                             AND CP.NRLANBOLPAG = BO.NRLANBOLPAG
                                             AND BO.CDFILIBAIPAG = BP.CDFILIAL
                                             AND BO.NRBAIXAPAG = BP.NRBAIXAPAG
                                             AND DTBAIXAPAG BETWEEN @V_DTINIC  AND @P_DTFINAL
                                             AND CP.CDFILIBPAG = @P_CDFILIAL
                                             AND TC.CDFILIAL  = @V_FILIALPAR
                                             AND TC.CDTPCTPAGAR = CP.CDTPCTPAGAR;



         OPEN C_CONTAPAGAR;
         FETCH NEXT FROM C_CONTAPAGAR  INTO @V_CDFILIBPAG, @V_CDFILIAL, @V_NRLANCTONF, @V_NRSEQVENPAG, @V_NRPARCELAPAG, @V_CDTPCTPAGAR, @V_DTBAIXAPAG, @V_VRCONTARATEADA;

         WHILE (@@FETCH_STATUS = 0)   BEGIN

            SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
            IF @V_DTLANCROP <> @V_DTBAIXAPAG BEGIN
               SET @V_NRROPFILIAL = NULL;
               SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
               FROM ROPFILIAL
               WHERE CDFILIAL    = @P_CDFILIAL AND
                     DTFILIALROP = @V_DTBAIXAPAG;

               SET @V_DTLANCROP   = @V_DTLANCDESFAT;
               IF @V_NRROPFILIAL IS NULL BEGIN
                  SET @V_NRROPFILIAL = @V_NRROPFILINI;
               END;

                           /* PEGA O ULTIMO NUMERO DO LANAMENTO */
               SELECT @V_NRLANCROP = MAX(NRLANCROP)
                 FROM LANCROPFILIAL
                 WHERE CDFILIAL = @P_CDFILIAL AND
                       NRROPFILIAL = @V_NRROPFILIAL;

               IF @V_NRLANCROP IS NULL BEGIN
                  SET @V_NRLANCROP  = 0;
                  SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
               END
               ELSE BEGIN
                  SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
               END;
            END;

            INSERT INTO LANCROPFILIAL
               (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
                NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, NRSEQVENPAGROP, NRPARCELAPAGROP, CDFILCENTROP)
            VALUES
               (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP,  @V_DTBAIXAPAG, 'DC', '', '',
               '', '', @V_CDFILIAL, @V_NRLANCTONF, @V_NRSEQVENPAG, @V_NRPARCELAPAG, @V_CDFILCENTPME);

            SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

            INSERT INTO ITLANCROPFILIAL
               (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
                NRSEQITPRODROP, CDITEMLANCROP, QTITEMLANCROP,    VRITEMLANCROP)
            VALUES
               (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, '', '',
                '',  @V_CDTPCTPAGAR,  1, @V_VRCONTARATEADA);

            FETCH NEXT FROM C_CONTAPAGAR  INTO @V_CDFILIBPAG, @V_CDFILIAL, @V_NRLANCTONF, @V_NRSEQVENPAG, @V_NRPARCELAPAG, @V_CDTPCTPAGAR, @V_DTBAIXAPAG, @V_VRCONTARATEADA;
         END;
         CLOSE C_CONTAPAGAR;
         DEALLOCATE C_CONTAPAGAR;
      END;
   END;

   /*custo padrao do servico*/

   SET @V_NRITLANCROP = '00000';
   SET @V_DTLANCROP = CONVERT(DATETIME,'01/01/1990');
   DECLARE  C_CUSTPADR CURSOR FOR
      SELECT C.CDFILIAL, DTREFCUSPADR, SUM(C.VRCUSTPADR) AS VRCUSTPDR
        FROM CUSTPADR C, SERVICO S
       WHERE (C.CDFILIAL     = @P_CDFILIAL)
         AND (C.DTREFCUSPADR BETWEEN @V_DTINIC  AND @P_DTFINAL)
         AND (S.CDFILIAL     = C.CDFILIAL)
         AND (S.CDSERVFILI   = C.CDSERVFILI)
         AND (S.IDSERVPRINC  = 'S')
       GROUP BY C.CDFILIAL, DTREFCUSPADR;

   OPEN C_CUSTPADR;
   FETCH NEXT FROM C_CUSTPADR  INTO @V_CDFILIAL, @V_DTLANCPADR, @V_VRCUSTPADR;

   WHILE (@@FETCH_STATUS = 0)   BEGIN
      SET @V_NRLANCROP = RIGHT('0000000000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRLANCROP) + 1)), 10);
      IF @V_DTLANCROP <> @V_DTLANCPADR BEGIN
         SET @V_NRROPFILIAL = NULL;
         SELECT @V_NRROPFILIAL = MAX(NRROPFILIAL)
         FROM ROPFILIAL
         WHERE CDFILIAL    = @P_CDFILIAL AND
               DTFILIALROP = @V_DTLANCPADR;

         SET @V_DTLANCROP   = @V_DTLANCPADR;
         IF @V_NRROPFILIAL IS NULL BEGIN
            SET @V_NRROPFILIAL = @V_NRROPFILINI;
         END;
      END;

      INSERT INTO LANCROPFILIAL
         (CDFILIAL, NRROPFILIAL,  NRLANCROP,  DTLANCROP, IDTPLANCROP, CDCLIENTEROP, CDTIPOOPERROP,
          NRNOTAFISCROP,    CDSERIENFROP,    CDFILIALNFROP,    NRLANCTONFROP, CDFILCENTROP)
      VALUES
         (@P_CDFILIAL, @V_NRROPFILIAL, @V_NRLANCROP, @V_DTLANCPADR, 'PP', '',
          '',  '', '', @V_CDFILIAL, '', @V_CDFILCENTROP);


      SET @V_NRITLANCROP = RIGHT('00000'+ CONVERT(CHAR(4), (CONVERT(INT, @V_NRITLANCROP) + 1)), 5);

      INSERT INTO ITLANCROPFILIAL
         (CDFILIAL, NRROPFILIAL, NRLANCROP, NRITLANCROP, CDFILIALNFITROP, NRLANCTONFITROP,
          NRSEQITPRODROP, CDITEMLANCROP,QTITEMLANCROP,    VRITEMLANCROP)
      VALUES
         (@P_CDFILIAL,  @V_NRROPFILIAL, @V_NRLANCROP, @V_NRITLANCROP, @V_CDFILIAL, '',
          '', '',  1, @V_VRCUSTPADR);

      FETCH NEXT FROM C_CUSTPADR  INTO @V_CDFILIAL, @V_DTLANCPADR, @V_VRCUSTPADR;

   END;
   CLOSE C_CUSTPADR;
   DEALLOCATE C_CUSTPADR;


   /* Apurao do Consumo -  Perodo Consumo = Considera Consumo Anterior */

   SET @V_DTINICIO = @P_DTINICIAL;
   SET @V_DTFINAL  = @P_DTINICIAL;

   IF (@V_IDPERCONSROP = 'P') AND  (@V_NRMESCONSROP > 1) AND (@P_IDCONSANT = 'N') BEGIN
      SET @V_NRCOUNT   = 0;
      WHILE (@V_NRCOUNT < @V_NRMESCONSROP) BEGIN

         SELECT @V_DTINICIO = '01/' + CASE RIGHT('00'+ CONVERT(VARCHAR,DATEPART(MONTH, @V_DTINICIO)),2) WHEN '01'
                 THEN '12/'+ CONVERT( VARCHAR, DATEPART(YEAR, @V_DTINICIO)-1)
                 ELSE RIGHT('00'+ CONVERT(VARCHAR, DATEPART(MONTH, @V_DTINICIO)-1 ), 2)+'/'+ CONVERT(VARCHAR,DATEPART(YEAR,@V_DTINICIO)) END

         SELECT @V_DTFINAL = MAX(DTDATA)
         FROM DATA
         WHERE DATEPART(MONTH, @V_DTINICIO) = DATEPART(MONTH, DTDATA)  AND
         DATEPART(YEAR, @V_DTINICIO) = DATEPART(YEAR, DTDATA)

         SET @V_NRCONS = 0;
         SELECT @V_NRCONS  = COUNT(*)
         FROM ROPFILIAL
         WHERE
            CDFILIAL    = @P_CDFILIAL   AND
            DTFILIALROP BETWEEN @V_DTINICIO AND @V_DTFINAL;
         IF @V_NRCONS = 0 BEGIN
            EXEC TEKNISA.APURAC_RESOPERFILI @P_CDFILIAL, @V_DTINICIO, @V_DTFINAL, 'S';
         END;
         SET @V_NRCOUNT = @V_NRCOUNT + 1;
      END;
   END;


   IF @V_IDFECHDIAROP = 'S'  BEGIN
      UPDATE APURACAOROP
      SET DTINIAPURACROP  = @P_DTFINAL + 1,
          DTFINAPURACROP  = @P_DTFINAL + 1
      WHERE CDFILIAL = @P_CDFILIAL;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APURAC_RESOPERFILI_DRF','5.09.000';
GO

